// POV 2

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

camera {
   location < 1, 0, -35 >
   direction < 0, 0, 1 >
   up  < 0, 1, 0 >
   right < 4 / 3, 0, 0 >
   look_at < 1, 0, 0 >
}

// Light source

object { light_source { < 25, 20, -150 > color White } }
object { light_source { < -25, 20, -150 > color White } }

object {
    sphere { < 0, -4000, 0 > 5000 }
    texture {
        pigment {
            Bright_Blue_Sky
            scale < 600, 240, 240 >
        }
        finish {
            ambient 1.0
            diffuse 0.0
        }
    }
}

// Floor plane

#declare Cube = box { < -0.5, -0.5, -0.5 >, < 0.5, 0.5, 0.5 > }

#declare Case_Wood =
pigment {
    wood
    turbulence 0.06
    color_map {
        [ 0.00 color red 0.59 green 0.41 blue 0.25 ]
        [ 0.95 color red 0.36 green 0.25 blue 0.20 ]
        [ 1.00 color red 0.35 green 0.16 blue 0.14 ]
    }
    scale < 0.3, 0.3, 0.3 >
}

#declare BoxWidth = 36
#declare BoxHeight = 28
#declare BoxDepth = 1.5

#declare Center1 = ( BoxWidth / 6 ) * -2.5
#declare Center2 = ( BoxWidth / 6 ) * -1.5
#declare Center3 = ( BoxWidth / 6 ) * -0.5
#declare Center4 = ( BoxWidth / 6 ) * 0.5
#declare Center5 = ( BoxWidth / 6 ) * 1.5
#declare Center6 = ( BoxWidth / 6 ) * 2.5

#declare Slat =
object {
    Cube
    scale < BoxWidth / 8, BoxHeight, 0.5 >
}


#declare CenterBox =
union {
    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < 4, 3, 2 >
            }
        }
        translate < Center1, 0, 0 >
    }

    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < 3, -5, -2 >
            }
        }
        translate < Center2, 0, 0 >
    }

    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < -4, 6, 8 >
            }
        }
        translate < Center3, 0, 0 >
    }

    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < 1, -2, 3 >
            }
        }
        translate < Center4, 0, 0 >
    }

    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < 3, 2, -1 >
            }
        }
        translate < Center5, 0, 0 >
    }

    object {
        Slat
        texture {
            pigment {
                Case_Wood
                rotate < 0, 0, 0 >
            }
        }
        translate < Center6, 0, 0 >
    }
}

object { CenterBox }
