// Source: BLOBIT.POV
// Desc  : A grid of blob objects is intersected by three larger blobs.
//       : Intended for animation between +k values of 0 thru 49.
// Ver   : POVRay 2.0
// Author: Crew Reynolds
// Date  : December 10, 1993

#include "colors.inc"
#include "textures.inc"

#declare LightX = 15
#declare LightY = 140
#declare LightZ = -300
#declare Width = 80
#declare radius1 = 50
#declare step = 68
#declare strength = 1
#declare yposdn = 320-(clock*4)
#declare yposup = clock*4-80

#declare SphereTexture = texture {
    pigment { Red }
    finish { Shiny ambient 0.1 }
}

light_source {
    <0, LightY, LightZ> color White
}

camera {
    location <0, 0, -240>
    look_at <0, 90, 0>
}

object {
   blob {
    threshold 0.8
    component strength*1.8, 80, <   0, yposdn, 0>
    component strength*1.8, 80, <-160, yposdn, 0>
    component strength*1.8, 80, < 160, yposdn, 0>
    
    component strength*1.8, 80, <   0, yposup, 0>
    component strength*1.8, 80, <-160, yposup, 0>
    component strength*1.8, 80, < 160, yposup, 0>
    
    component strength, radius1, <-Width, 0, 0 >
    component strength, radius1, <+Width, 0, 0 >

    component strength, radius1, <-Width, step*1, 0 >
    component strength, radius1, <+Width, step*1, 0 >
                    
    component strength, radius1, <-Width, step*2, 0 >
    component strength, radius1, <+Width, step*2, 0 >

    component strength, radius1, <-Width, step*3, 0 >
    component strength, radius1, <+Width, step*3, 0 >

    component strength, radius1, <-Width, step*4, 0 >
    component strength, radius1, <+Width, step*4, 0 >

    component strength, radius1, <-Width, step*5, 0 >
    component strength, radius1, <+Width, step*5, 0 >

    component strength, radius1, <-Width, step*6, 0 >
    component strength, radius1, <+Width, step*6, 0 >

    component strength, radius1, <-Width, step*7, 0 >
    component strength, radius1, <+Width, step*7, 0 >

    component strength, radius1, <-Width, step*8, 0 >
    component strength, radius1, <+Width, step*8, 0 >
   
  }
  texture{ SphereTexture }
}

