/*

Cloudy Planet for PovRay Version 2.1

Crafted By Editor, Whirl3d and POVRAY (Cheers team, great software.)

Created by Mike Young.

*/

#include "colors.inc"    // The include files contain
#include "shapes.inc"    // pre-defined scene elements
#include "shapes2.inc"   // pre-defined scene elements
#include "textures.inc"

#declare Object_Size = 1.25
#declare MyFinish = finish { ambient .3 reflection .3 }

#declare Xloc = 60	// Camera position
#declare Yloc = -85
#declare Zloc = -60

#declare LXloc = 100	// Light position
#declare LYloc = -100
#declare LZloc = -20

camera {
 location <Xloc,Yloc,Zloc>
 direction < 0 , 0, 1>
 look_at <0,0,0>
}

light_source {
 <LXloc,LYloc,LZloc> color White
}


#declare Point001_Texture = texture { pigment {Red} finish {MyFinish}}
#declare Point002_Texture = texture { pigment {Green} finish {MyFinish}}
#declare Point003_Texture = texture { pigment {Blue} finish {MyFinish}}
#declare Point004_Texture = texture { Silver_Metal finish {MyFinish}}
#declare Point005_Texture = texture { Chrome_Metal finish {MyFinish}}

#declare Point001_Object = sphere { <0,0,0>,Object_Size no_shadow}
#declare Point002_Object = sphere { <0,0,0>,Object_Size no_shadow}
#declare Point003_Object = sphere { <0,0,0>,Object_Size no_shadow}
#declare Point004_Object = sphere { <0,0,0>,Object_Size no_shadow}
#declare Point005_Object = sphere { <0,0,0>,Object_Size no_shadow}

sphere { < 0, 0, 0>, 25
 texture  {
  pigment {bozo
   color_map {
    [0  color Clear]
    [.1 color Red]
    [.5 color Yellow]
    [.9 color Red]
    [1  color Clear]
   }
   turbulence 0.2  lambda .2  omega 0.25  octaves 4
  scale 8
  }
 finish {ambient .3}
 }
 rotate y*clock
 no_shadow
}

sphere { < 0, 0, 0>, 30
 texture  {
  pigment {bozo
   color_map {
    [0   color Clear]
    [.35 color White]
    [.37 color Clear]
    [.4  color Gray20]
    [.45 color Clear]
   }
   scale 2
  }
 }
 rotate y*(360-clock)
}

