//  Persistance of Vision Raytracer V2.0
//  World definition file.
//
//  Contains 8 lights, 14 textures and 71 primitives.
//
//  This file was generated for POV-Ray V2.0 by
//  MORAY.EXE (c) '91 '92 '93 SoftTronics by Lutz Kretzschmar + Markus Lutz
//
//  Fearless LL83z By Stephen Beardmore 
//  (c) 1993 Stephen Beardmore
//
//  Date : 10/15/1993    (15.10.1993)
//


#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

#declare BezFlatness = 0.01
#declare BezUStep    = 3
#declare BezVStep    = 3

camera {  //  Camera Camera03
  location  <22.744, -13.446, 9.852>
  direction <0.0,     0.0,  1.9361>
  sky       <0.0,     0.0,  1.0>  // Use right handed-system!
  up        <0.0,     0.0,  1.0>  // Where Z is up
  right     <1.3333,  0.0,  0.0>
  look_at   <-0.021, 0.841, 0.326>
}

// *******  L I G H T S *******
object {   // Light source Light001
  light_source {
    <50.228, 26.537, 28.515>
    color  red 0.7000 green 0.7000 blue 0.7000
  }
}


object {   // Light source flamelite7
  light_source {
    <0.593, -6.450, 1.229>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite
  light_source {
    <1.095, -6.450, 0.663>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite1
  light_source {
    <0.000, -6.450, 1.514>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite2
  light_source {
    <-0.014, -6.450, -0.323>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite6
  light_source {
    <0.715, -6.450, -0.052>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite3
  light_source {
    <-1.054, -6.450, 0.622>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite5
  light_source {
    <-0.675, -6.450, -0.134>
    color  red 1.000 green 0.922 blue 0.557
  }
}

object {   // Light source flamelite4
  light_source {
    <-0.614, -6.450, 1.202>
    color  red 1.000 green 0.922 blue 0.557
  }
}


//
// ********  T E X T U R E S  *******
//

#include "AREAFR2.INC"

// ********  O B J E C T S *******
#declare Bound001 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <2.950723, 2.355651, 1.493824>
  translate <0.000000, 0.934920, 0.972025>
}

#declare Sphere001 = object { 
  sphere {<0,0,0>,1}
  texture {
    imagetex
    scale <2.660000, 2.000000, 1.000000>
    translate <-1.330000, -1.000000, -0.570097>
  }
  scale <2.000000, 1.300000, 0.250000>
  translate <-0.011373, 0.000000, 0.302557>
}

#declare WingCutter2 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    SideCutTex1
    scale <12.000000, 2.000000, 1.000000>
    rotate <-0.000000, -86.612968, -0.000000>
    translate <-0.478013, -1.026875, -3.201729>
  }
  scale <0.500000, 1.500000, 0.500000>
  rotate <-0.000000, 15.000000, -10.000000>
  translate <-2.000000, 0.250000, 0.306834>
}

#declare Cube001 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    SideCutTex1
    scale <12.000000, 2.000000, 1.000000>
    rotate <-0.000000, -86.612968, -0.000000>
    translate <-0.478013, -1.026875, -3.201729>
  }
  scale <0.250000, 1.000000, 1.000000>
  rotate <39.068562, -0.000000, -0.100447>
  translate <0.610000, 1.796310, 0.972025>
}

#declare WingCutter3 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    SideCutTex1
    scale <12.000000, 2.000000, 1.000000>
    rotate <-0.000000, -86.612968, -0.000000>
    translate <-0.478013, -1.026875, -3.201729>
  }
  scale <0.500000, 1.500000, 0.500000>
  rotate <-0.000000, -15.000000, 10.000000>
  translate <2.000000, 0.250000, 0.306834>
}

#declare Thewing = difference {
  object { Sphere001 }
  object { WingCutter2 }
  object { Cube001 }
  object { WingCutter3 }
  bounded_by { Bound001 }
  scale <2.250000, 2.850000, 1.000000>
}

#declare Bound002 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <1.719250, 6.704166, 1.623285>
  translate <0.000000, 0.575363, 0.029257>
}

#declare Cylndr001 = cylinder {
  <0,0,1>, <0,0,0>, 1
  scale <0.750000, 0.750000, 10.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -5.000000, 0.000000>
}

#declare Hullrear = object { 
  sphere {<0,0,0>,1}
  scale <0.750000, 1.000000, 0.750000>
  translate <0.000000, -5.000000, 0.000000>
}

#declare BasicHull = union {
  object { Cylndr001 }
  object { Hullrear }
  texture {
    Hull_Tex01
  }
}

#declare HullCut1 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <0.500000, 3.000000, 1.000000>
  rotate <-0.000000, 8.000000, -3.000000>
  translate <-0.800000, 3.050000, 0.000000>
}

#declare HullCut2 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <0.500000, 3.000000, 1.000000>
  rotate <-0.000000, -8.000000, 3.000000>
  translate <0.800000, 3.050000, 0.000000>
}

#declare Cutter3 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <1.000000, 5.000000, 0.370023>
  rotate <-4.000000, -0.000000, -0.000000>
  translate <0.000000, 2.137094, 0.805834>
}

#declare Cutter4 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <1.000000, 3.000000, 0.370023>
  rotate <2.000000, -0.000000, -0.000000>
  translate <0.000000, 2.112275, -0.500000>
}

#declare Cutter5 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <1.000000, 0.500000, 0.370023>
  rotate <45.000000, -0.000000, -0.000000>
  translate <0.000000, -0.989413, -0.850024>
}

#declare Cutter6 = box {
  <-1, -1, -1>, <1, 1, 1>
  scale <1.000000, 0.500000, 0.370023>
  rotate <-30.000000, -0.000000, -0.000000>
  translate <0.000000, 4.912694, 0.418208>
}

#declare Intakecutter = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.633906, 0.633906, 2.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -1.852331, 0.000000>
}

#declare Gunport = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.050000, 0.050000, 2.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 0.961900, 0.450251>
}

#declare Hull = difference {
  object { BasicHull }
  object { HullCut1 }
  object { HullCut2 }
  object { Cutter3 }
  object { Cutter4 }
  object { Cutter5 }
  object { Cutter6 }
  object { Intakecutter }
  object { Gunport }
  texture {
    Hull_Tex01
  }
  bounded_by { Bound002 }
  scale <1.000000, 1.000000, 0.750000>
  translate <0.000000, 2.000000, 0.350000>
}

#declare Bound003 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <4.110757, 2.393610, 2.134682>
  translate <0.000000, -1.705706, 1.119106>
}

#declare Cube002 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <0.050000, 1.000000, 1.500000>
  rotate <-0.000000, 15.000000, -0.000000>
  translate <3.250000, -1.785949, 1.000000>
}

#declare Cube1 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    FinTex2
  }
  scale <0.050000, 1.000000, 1.500000>
  rotate <-0.000000, -15.000000, -0.000000>
  translate <-3.250000, -1.785949, 1.000000>
}

#declare Tail1 = union {
  object { Cube002 }
  object { Cube1 }
  scale <0.750000, 1.000000, 1.000000>
  rotate <-180.000000, -0.000000, -0.000000>
  translate <0.000000, -3.640000, 2.064124>
}

#declare Cube003 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.500000, 2.000000>
  rotate <25.000000, -0.000000, -0.000000>
  translate <0.000000, -0.721244, 1.119106>
}

#declare Cube4 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.500000, 1.000000>
  rotate <-17.143372, -0.000000, -0.000000>
  translate <0.000000, -3.216011, 1.839129>
}

#declare Cube5 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.500000, 0.500000>
  rotate <-45.000000, -0.000000, -0.000000>
  translate <0.000000, -2.875770, -0.068178>
}

#declare Fins = difference {
  object { Tail1 }
  object { Cube003 }
  object { Cube4 }
  object { Cube5 }
  texture {
    Ring_Tex
  }
  bounded_by { Bound003 }
  scale <1.000000, 0.750000, 0.800000>
  rotate <5.000000, -0.000000, -0.000000>
  translate <0.000000, -1.000000, 0.750000>
}

#declare Bound004 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <4.112748, 2.246706, 2.434871>
  translate <0.000000, -1.854601, 0.858244>
}

#declare Cube3 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    FinTex2
  }
  scale <0.050000, 1.000000, 1.500000>
  rotate <-0.000000, 15.000000, -0.000000>
  translate <1.850000, -1.785949, 1.000000>
}

#declare Cube2 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    FinTex2
  }
  scale <0.050000, 1.000000, 1.500000>
  rotate <-0.000000, -15.000000, -0.000000>
  translate <-1.800000, -1.785949, 1.000000>
}

#declare Tail2 = union {
  object { Cube3 }
  object { Cube2 }
  scale <0.750000, 1.000000, 1.000000>
  rotate <-180.000000, -0.000000, -0.000000>
  translate <0.000000, -3.680000, 2.125582>
}

#declare Cube6 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.500000, 2.000000>
  rotate <15.000000, -0.000000, -0.000000>
  translate <0.000000, -0.721244, 1.119106>
}

#declare Cube7 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.500000, 1.000000>
  rotate <-17.143372, -0.000000, -0.000000>
  translate <0.000000, -3.216011, 1.839129>
}

#declare Cube8 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Ring_Tex
  }
  scale <4.000000, 0.750000, 0.750000>
  rotate <-45.000000, -0.000000, -0.000000>
  translate <0.000000, -2.917651, -0.403220>
}

#declare Fins1 = difference {
  object { Tail2 }
  object { Cube6 }
  object { Cube7 }
  object { Cube8 }
  texture {
    Ring_Tex
  }
  bounded_by { Bound004 }
  scale <1.500000, 0.750000, 0.500000>
  rotate <-180.000000, -0.000000, -180.000000>
  translate <0.000000, -1.449781, 0.125072>
}

#declare Bound005 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <0.439535, 1.733284, 0.520908>
  translate <0.000000, 0.701251, -0.073668>
}

#declare Canopy1 = object { 
  sphere {<0,0,0>,1}
  texture {
    Canopy_tex
  }
  scale <0.400000, 0.400000, 0.400000>
  translate <0.000000, 2.000000, 0.000000>
}

#declare Canopy2 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Canopy_tex
  }
  scale <0.400000, 0.400000, 3.000000>
  rotate <-87.000000, -0.000000, -0.000000>
  translate <0.000000, -0.976563, -0.160589>
}

#declare Frame = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.405000, 0.405000, 0.050000>
  rotate <-80.000000, -0.000000, -0.000000>
  translate <0.000000, 1.493229, 0.005175>
}

#declare Cockpit = union {
  object { Canopy1 }
  object { Canopy2 }
  object { Frame }
  bounded_by { Bound005 }
  translate <0.000000, 0.000000, 0.600000>
}

#declare Nozzle1 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle2 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.200000, 0.200000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare Jetipe1 = difference {
  object { Nozzle1 }
  object { Nozzle2 }
  translate <0.004350, 0.000000, 0.004350>
}

#declare Nozzle4 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle5 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.200000, 0.200000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare JetPipe2 = difference {
  object { Nozzle4 }
  object { Nozzle5 }
  rotate <-5.000000, -0.000000, -2.000000>
  translate <0.384601, 0.000000, 0.000000>
}

#declare Nozzle6 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle7 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.200000, 0.200000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare JetPipe3 = difference {
  object { Nozzle6 }
  object { Nozzle7 }
  rotate <-5.000000, -0.000000, 2.000000>
  translate <1.129027, 0.000000, 0.000000>
}

#declare Nozzle8 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle9 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.200000, 0.200000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare JetPipe4 = difference {
  object { Nozzle8 }
  object { Nozzle9 }
  translate <1.504000, 0.000000, 0.004350>
}

#declare Nozzle10 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle11 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.200000, 0.200000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare JetPipe5 = difference {
  object { Nozzle10 }
  object { Nozzle11 }
  rotate <-5.000000, -0.000000, -0.000000>
  translate <0.752000, 0.023530, 0.104888>
}

#declare Nozzle12 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    NewNoz
  }
  scale <0.250000, 0.250000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.750000, 0.545366>
}

#declare Nozzle13 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    GlowTex
  }
  scale <0.220000, 0.220000, 0.500000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <-0.756835, -3.850000, 0.545366>
}

#declare JetPipe6 = difference {
  object { Nozzle12 }
  object { Nozzle13 }
  scale <1.250000, 1.250000, 1.250000>
  translate <0.946300, 1.059274, -0.240483>
}

#declare Bound006 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <1.567730, 2.147509, 1.567730>
  translate <0.000000, -1.920222, 0.415514>
}

#declare Engine = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.250000, 0.250000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -6.000000, 0.800000>
}

#declare EngCut1 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.200000, 0.200000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -3.900000, 0.775000>
}

#declare Engines = difference {
  object { Engine }
  object { EngCut1 }
  scale <1.000000, 1.000000, 0.750000>
  translate <0.000000, 2.000000, 0.400000>
}

#declare Engine1 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.250000, 0.250000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -6.000000, 0.800000>
}

#declare EngCut2 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.200000, 0.200000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -3.900000, 0.775000>
}

#declare Engines1 = difference {
  object { Engine1 }
  object { EngCut2 }
  scale <1.000000, 1.000000, 0.750000>
  translate <0.750000, 2.000000, -0.050000>
}

#declare Engine2 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.250000, 0.250000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -6.000000, 0.800000>
}

#declare EngCut3 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.200000, 0.200000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -3.900000, 0.775000>
}

#declare Engines2 = difference {
  object { Engine2 }
  object { EngCut3 }
  scale <1.000000, 1.000000, 0.750000>
  translate <-0.750000, 2.000000, -0.050000>
}

#declare Engine3 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.250000, 0.250000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -6.000000, 0.800000>
}

#declare EngCut4 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.200000, 0.200000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -3.900000, 0.775000>
}

#declare Engines3 = difference {
  object { Engine3 }
  object { EngCut4 }
  scale <1.000000, 1.000000, 0.750000>
  translate <-0.500000, 2.000000, 0.300000>
}

#declare Engine4 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.250000, 0.250000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -6.000000, 0.800000>
}

#declare EngCut5 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.200000, 0.200000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, -3.900000, 0.775000>
}

#declare Engines4 = difference {
  object { Engine4 }
  object { EngCut5 }
  scale <1.000000, 1.000000, 0.750000>
  translate <0.500000, 2.000000, 0.300000>
}

#declare All_Engine = union {
  object { Engines }
  object { Engines1 }
  object { Engines2 }
  object { Engines3 }
  object { Engines4 }
}

#declare Cone2 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    Hull_Tex01
  }
  scale <1.500000, 1.500000, 1.750000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <0.000000, 0.309556, 0.415514>
}

#declare Cone001 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    Hull_Tex01
  }
  scale <1.100000, 1.100000, 1.250000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <0.000000, -0.190444, 0.415514>
}

#declare ConeCut1 = difference {
  object { Cone2 }
  object { Cone001 }
  translate <0.000000, -0.150000, 0.000000>
}

#declare SlopeEngines = difference {
  object { All_Engine }
  object { ConeCut1 }
  texture {
    Hull_Tex01
  }
  bounded_by { Bound006 }
}

#declare InnerIntake = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Hull_Tex01
  }
  scale <0.420000, 0.500000, 0.250000>
  translate <0.000000, 2.022531, 0.470263>
}

#declare The_Ship = union {
  object { Thewing }
  object { Hull }
  object { Fins }
  object { Fins1 }
  object { Cockpit }
  object { Jetipe1 }
  object { JetPipe2 }
  object { JetPipe3 }
  object { JetPipe4 }
  object { JetPipe5 }
  object { JetPipe6 }
  object { SlopeEngines }
  object { InnerIntake }
}

#declare Bound007 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <0.476333, 1.875856, 0.152106>
  translate <2.111618, 3.756250, 0.300000>
}

#declare Gunbase1 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    Cop_Tex
  }
  scale <0.120000, 0.120000, 2.000000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <0.000000, 4.150000, 0.300000>
}

#declare Gunbit3 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Cop_Tex
  }
  scale <0.080000, 0.080000, 0.500000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 3.500000, 0.300000>
}

#declare Gun1 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.050000, 0.050000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 1.550000, 0.300000>
}

#declare insideGun1 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.030000, 0.030000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <-0.000000, 3.750000, 0.300000>
}

#declare Barrel = difference {
  object { Gun1 }
  object { insideGun1 }
}

#declare Gun = union {
  object { Gunbase1 }
  object { Gunbit3 }
  object { Barrel }
  scale <1.000000, 0.750000, 1.000000>
  translate <2.435844, 0.750000, 0.000000>
}
#declare Gunbase3 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    Cop_Tex
  }
  scale <0.120000, 0.120000, 2.000000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <0.000000, 3.500000, 0.300000>
}

#declare Gunbit5 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Cop_Tex
  }
  scale <0.080000, 0.080000, 0.500000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 3.500000, 0.300000>
}

#declare Gun7 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.050000, 0.050000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 1.550000, 0.300000>
}

#declare insideGun3 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.030000, 0.030000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <-0.000000, 3.750000, 0.300000>
}

#declare Barrel2 = difference {
  object { Gun7 }
  object { insideGun3 }
}

#declare Gun5 = union {
  object { Gunbase3 }
  object { Gunbit5 }
  object { Barrel2 }
  scale <1.000000, 0.750000, 1.000000>
  translate <1.787391, 1.250000, 0.000000>
}
#declare Gunbase2 = cone {
  <0,0,0>, 0
  <0,0,1>, 1
  texture {
    Cop_Tex
  }
  scale <0.120000, 0.120000, 2.000000>
  rotate <-270.000000, -0.000000, -0.000000>
  translate <0.000000, 3.500000, 0.300000>
}

#declare Gunbit4 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Cop_Tex
  }
  scale <0.080000, 0.080000, 0.500000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 3.500000, 0.300000>
}

#declare Gun2 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Hull_Tex01
  }
  scale <0.050000, 0.050000, 3.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <0.000000, 1.550000, 0.300000>
}

#declare insideGun2 = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    INBARREL01
  }
  scale <0.030000, 0.030000, 1.000000>
  rotate <-90.000000, -0.000000, -0.000000>
  translate <-0.000000, 3.750000, 0.300000>
}

#declare Barrel1 = difference {
  object { Gun2 }
  object { insideGun2 }
}

#declare Gun3 = union {
  object { Gunbase2 }
  object { Gunbit4 }
  object { Barrel1 }
  translate <2.100000, 0.850000, 0.000000>
}
#declare Guns = union {
  object { Gun }
  object { Gun5 }
  object { Gun3 }
  bounded_by { Bound007 }
  translate <-0.740980, 0.374821, 0.000000>
}
#declare Bound008 = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
  scale <0.421053, 1.309007, 0.421053>
  translate <0.000000, -7.803674, 0.476370>
}

#declare Flame = cylinder {
  <0,0,1>, <0,0,0>, 1
  texture {
    Flame_Tex
    rotate <-0.000000, -0.000000, -180.000000>
  }
  scale <0.250000, 0.250000, 2.000000>
  rotate <90.000000, -0.000000, -0.000000>
  translate <-0.000000, -6.522246, 0.446148>
}

#declare Cube004 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    BlackTex
  }
  scale <0.393474, 0.393474, 0.393474>
  translate <0.000000, -8.691629, 0.476370>
}

#declare Flame1 = difference {
  object { Flame }
  object { Cube004 }
  bounded_by { Bound008 }
  scale <1.944652, 1.500000, 1.910000>
  translate <0.000000, 5.437930, -0.250000>
}

#declare NavLight1 = object { 
  sphere {<0,0,0>,1}
  texture {
    RedNavTex
  }
  scale <0.050000, 0.050000, 0.050000>
  translate <2.156106, -4.537686, 2.620123>
}

#declare NavLight2 = object { 
  sphere {<0,0,0>,1}
  texture {
    RedNavTex
  }
  scale <0.050000, 0.050000, 0.050000>
  translate <-2.158644, -4.537686, 2.624518>
}

#declare NavLight3 = object { 
  sphere {<0,0,0>,1}
  texture {
    RedNavTex
  }
  scale <0.050000, 0.050000, 0.050000>
  translate <0.000000, 2.239077, 1.007511>
}

#declare NavLight4 = object { 
  sphere {<0,0,0>,1}
  texture {
    RedNavTex
  }
  scale <0.050000, 0.050000, 0.050000>
  translate <0.000000, 0.470099, -0.333099>
}

#declare NavLites = union {
  object { NavLight1 }
  object { NavLight2 }
  object { NavLight3 }
  object { NavLight4 }
  scale <1.000000, 0.650000, 1.000000>
}
union {   // All
  object { The_Ship }
  object { Guns }
  object { Flame1 }
  object { NavLites }
  scale <1.000000, 1.500000, 1.000000>
}
box {   // ground1
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Stars2_Tex
    scale <0.250000, 0.250000, 0.250000>
    rotate <-30.000000, -0.000000, -0.000000>
    translate <-1.000000, -1.000000, 1.000000>
  }
  scale <6000.000000, 6000.000000, 200.000000>
  rotate <-180.000000, -0.000000, -0.000000>
  translate <13.412847, 32.862584, -275.000000>
}

