//Mr. Miface sees himself in a typical Povray scene.
//by Blane Bizzaro
//This file requires "miface.inc"
//Face data provided by Mira Imaging <thanks>
//Use +mv1 option to render
//This file is released to the public domain with
//no strings attached. :)

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

camera {
   location  <0, 0, -3>
   direction <0, 0, 1>
   up        <0, 1, 0>
   right     <1.33333, 0, 0>
   look_at   <0, 0, -10> 
}

object { light_source { <5, 20, -30> color Orange }}
object { light_source { <-15, 10, -10> color SteelBlue }}

fog {color red 0.7 green 0.7 blue 0.9 distance 6000 }

#declare Face_Texture = texture {
   color White
   phong 1
   phong_size 100
   ambient 0.2
   diffuse 0.8
}

#declare FaceThing = composite {
   composite {
      #include "miface.inc"
      rotate <0 90 90>
      scale <50, 50, 50>
      translate <0, 50, 150>
   }
}

composite { FaceThing }

//The water

plane {y, -500
   texture {
      pigment { color red 0.3 green 0.5 blue 0.6 }
      finish {
         reflection 0.45
         ambient 0.1
         diffuse 0.6 phong 1.0 phong_size 80
      }
      normal {
         ripples 0.7
         frequency 0.08
      }
}}
sphere { <0, 0, -10> 3 
texture { pigment { color Brass } finish { Metal }
}}

//Sky
sphere { <0, -39000, 0> 40000
   inverse
   pigment {
     bozo
     turbulence 0.6
     color_map {
        [0 0.5 color red 0.4 green 0.5 blue 1
               color red 0.4 green 0.5 blue 1.0]
        [0.5 0.7 color red 0.4 green 0.5 blue 1
                 color red 1 green 1 blue 1.0]
        [0.7 1 color red 1 green 1 blue 1
               color red 0.7 green 0.7 blue 0.7
     ]}
     scale 500
     quick_color red 0.4 green 0.5 blue 1
   }
   finish {
   ambient 1
   diffuse 0
   }
}
