// POV-Ray 2.n scene file.
// Copyright 1994 by Dan Farmer.  All Rights Reserved
// This scene file may be used freely for personal use and as a learning
// example but permission is required for any form of commercial use or 
// distribution in whole or in part of the scene description or the 
// resulting image.
//  Dan Farmer 
//  CIS [74431,1075]
//  internet 74431.1075@compuserve.com
//==================================================================
// This is a three-layer wood texture.  Renders rather slowly because of
// the transparent layers and the two layers of turbulence, but it looks
// great.  Try other colors of "varnish" for simple variations.  
#declare DMFWood6 = 
texture {
    pigment {
        wood  turbulence 0.04
        octaves 3
        scale <0.05, .05, 1>
        color_map { 
            [0.00, 0.10 color red 0.888 green 0.600 blue 0.4
                        color red 0.888 green 0.600 blue 0.4]
            [0.10, 0.90 color red 0.888 green 0.600 blue 0.4
                        color red 0.6 green 0.4 blue 0.3]
            [0.90, 1.0  color red 0.6 green 0.4 blue 0.3
                        color red 0.6 green 0.4 blue 0.3]
        }
    }
    finish { ambient 0.45 diffuse 0.5 }
}
texture {
    pigment {
        wood  turbulence <0.1 , 0.5, 1> 
        octaves 5
        lambda 3.25
        scale <0.15, .5, 1>
        color_map { 
            [0.00, 0.10 color red 0.7 green 0.6 blue 0.4 filter 0.1 
                        color red 0.8 green 0.6 blue 0.3 filter 0.5 ]
            [0.10, 0.90 color red 0.8 green 0.6 blue 0.3 filter 0.65
                        color red 0.6 green 0.4 blue 0.2 filter 0.975]
            [0.90, 1.0  color red 0.6 green 0.4 blue 0.2 filter 0.975
                        color red 0.6 green 0.4 blue 0.2 filter 1]
        }
    rotate <2, 2, 4>
    translate -x*2
    scale <1,1,2>        // not sure if this helps
    }
    finish { ambient .1 diffuse -0.5 }   // not sure if neg diffuse works
}
// A "coat of varnish" to modify the overall color of the wood
texture {
    pigment { rgbf <1, 0.25, 0.25, 1>}
    finish { 
        ambient 1 
        diffuse 1 
    }
}

// A plank that will be used to make up unique individual planks
#declare Board = 
object { Cube scale <1, 0.1, 20 > translate -y*0.1 }

// A union of several planks, each has the texture slightly modified
// for uniqueness.
#declare Boards = 
union {
    // 3rd left from center
    object { Board
        texture { DMFWood6 }
        translate <-6.1, 0, 0>
    }
    // 2nd left from center
    object { Board
        texture { DMFWood6
            scale 1.15
            rotate <180, 5, 10>
            translate z*10
        }
        translate <-4.05, 0, 0>
    }
    // 1st left from center
    object { Board
        texture { DMFWood6
            scale 1.2
            rotate <8, 0, 45>
            translate <-3, -3, -3>
            translate -z*10
        }
        translate <-2.05, 0, 0>
    }
    // Center board
    object { Board
        texture { DMFWood6
            rotate <180, 0, 90>
            translate <3, 3, 3>
            translate z*30
        }
    }

    // 1st right from center
    object { Board
        texture {
            DMFWood6
            rotate <180, 0, 0>
            scale 0.5
            translate <10, 10, 10>
        }
        translate <2.05, 0, 0>
    }

    // 2nd right from center
    object { Board
        texture {
            DMFWood6
            rotate <180, 0, 90>
            translate <3, 3, 3>
        }
        translate <4.05, 0, 0>
    }
}
