
#declare Tin = texture {
    pigment { color rgb < 0.741,  0.741,  0.788> }
    finish {
        ambient 0.2
        diffuse 0.7
        brilliance 6.0
        phong 0.75
        phong_size 60
        metallic
    }
}

#declare Label = texture {
    pigment { 
        image_map { tga "label.tga" 
            once 
            interpolate 4 
            map_type Plane_Map 
        }
        translate <-0.5, 0, 0>
        scale <2.5, 2, 1>
        rotate -y*210
    }
    finish { 
        specular 1
        roughness 0.1 
        metallic 
        brilliance 2.0
    }
}
#declare Can_Wall = 
union {
    cylinder { <0,0,0>, <0,2,0>, 0.99  open texture { Tin   } }
    cylinder { <0,0,0>, <0,2,0>, 1.00  open texture { Label } }
}

#declare Can_Bottom =  
union {
    disc { <0.0, 0.0, 0.0>, <0.0, 1.0, 0.0>, 1 }
    torus { 1.0, 0.05 }
    texture { Tin }
}


#declare Can_Top = union {
    torus { 1, 0.05 translate y*2.0 }

    torus { 0.9, 0.05 
        clipped_by { disc { <0.0, 0.0, 0.0>, y, 1.0 } }
        translate y * 1.975
    }

    torus { 0.85, 0.025 translate y * 1.975 }
    texture { Tin }
}

#declare Can =
union {
    object { Can_Wall }
    object { Can_Bottom }
    object { Can_Top }
}
