// POV-Ray 2.n scene file.
// Copyright 1994 by Dan Farmer.  All Rights Reserved
// This scene file may be used freely for personal use and as a learning
// example but permission is required for any form of commercial use or 
// distribution in whole or in part of the scene description or the 
// resulting image.
//  Dan Farmer 
//  CIS [74431,1075]
//  internet 74431.1075@compuserve.com
//==================================================================
// Requires:
//    spill.pov    : Main file.  Sets up camera and places objects.
//    boards.inc   : Wooden flooring composed of "boards".  
//    can.inc      : Varnish can.  Needs LABEL.TGA imagemap.
//    puddle.inc   : Blob used as spilled water.
//==================================================================

// General include files        
#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

// Scene-specific include files
#include "boards.inc"
#include "can.inc"
#include "puddle.inc"

#max_trace_level 10            // Lower this if you need to
background { color Gray35 }

camera {
  location <5, 8, -9>
  sky y
  right x*1.333
  direction z*2.25
  up       <0, 1, 0>
  look_at  <-0.2, 0.2, 0>
}

light_source{< -10 , 10 ,  -15  > color White 
    spotlight
    point_at <0,0,0>
    radius 30
    falloff 45
}

light_source{< 3, 10,  -10  > color White 
    spotlight
    point_at <0,0,0>
    radius 60
    falloff 75
}

object { Boards translate -x*1.5}
object { Puddle }
object { Can
    rotate -x*90
    translate y*1.1
    translate <-0.65, 0, 3.7>
    rotate -y*75
}

