// Persistence Of Vision raytracer version 1.0 scene file.
// This is the basic setup for viewing MIFACE.INC.
//
#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

camera {
   location <0.0  0  -12.0>
   direction <0.0 0.0  1.0>
   up  <0.0  1.0  0.0>
   right <1.33333 0.0 0.0>
   look_at <0 0 0>
}

// Light source
object { light_source {  < 5 20  -30> color Orange  }}
object { light_source {  <-15 10  -10> color SteelBlue  }}


#declare Face_Texture = texture {
    color White
    phong 1
    phong_size 100
    ambient 0.2
    diffuse 0.8
}


#declare FaceThing = composite {
    composite {
        #include "miface.inc"
        rotate <0 90 90>             // Makes a head-on view
    }
}

composite { FaceThing }     // Single face, straight-on view.

/******** Special Edition: Five-face version, if you've got the hardware!
#declare Group = composite {
    composite { FaceThing translate <+8 4 8> }
    composite { FaceThing translate <+4 2 4> }
    composite { FaceThing }
    composite { FaceThing translate <-4 2 4> }
    composite { FaceThing translate <-8 4 8> }
}

composite { Group }
object {
    plane { <0 1 0> -2 }
    texture {
        color Gray30
        reflection 0.25
        ambient 0.3
        diffuse 0.7
    }
}
****************************/
