#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "eelbody.inc"
#include "eelfin1.inc"
#include "eelfin2.inc"
#include "eelhole.inc"
#include "eelhole2.inc"

camera {
  location  <0 1 -15>
  direction <0 0 1.5>
  up        <0 1 0>
  right     <1.33 0 0>
  look_at   <0 0 2>
}

object {
  plane {<0 1 0> -4 }
  texture {
    color red 0.812 green 0.761 blue 0.455
    ambient 0.1
    diffuse 0.6
    ripples .35
    frequency 100
    turbulence 0.75
    scale <100 100 100>
   }
}

object { light_source { <2 10 -5> color White } }

object {
  sphere {<0 0 0> 1000}
  texture {color SlateBlue}
}

fog {
  color SlateBlue
  200 
}

#declare Eyeball =
  union {
    quadric {
      Ellipsoid
      texture {
        color White
        specular 1.0
        roughness .001
      }
      scale <1 .45 1>
      rotate <-90 0 0>
    }
    quadric {
      Ellipsoid
      texture {
        color Black
        specular 1.0
        roughness .001
      }
      scale <.5 .225 .5>
      rotate <-90 0 0>
      translate <0 0 -.45>
    }
  }

#declare YourTexture =
  texture {
    bozo
    color_map {
      [0.0 0.5 color White color White]
      [0.5 1.0 color Black color Black]
    }
    scale <.06 .06 .06>
    ambient 0.3
    diffuse 0.5
    specular .75
    roughness .001
  }

#declare Tooth1 = 
  intersection {
    Cone_Y
    scale <.1 .25 .1>
    rotate <0 0 180>
  }

#declare Tooth2 =
  intersection {
    Cone_Y
    scale <.1 .25 .1>
}
  
#declare ToothTexture =
  texture {
    color White
    specular .75
    ambient 0.3
    diffuse 0.5
  }  
  
composite {
  composite {
    EelBody
    scale <.25 .25 .15>
    translate <.15 0 0>
    clipped_by {
      quadric {
        Ellipsoid
        scale <.125 1 1>
        rotate <0 0 -70>
        translate <1.8 1.2 0>
        inverse
      }
    }
    clipped_by {
      quadric {
        Ellipsoid
        scale <.1 .6 .5>
        rotate <0 0 -90>
        translate <1.75 .825 0>
        inverse
      }
    }
  }
  composite {
    EelFin1
    scale <.225 .25 .025>
    rotate <0 0 -2>
    translate <0 .085 0>
  }
  composite {
    EelFin2
    scale <.18 .25 .025>
    rotate <0 0 -15>
    translate <-.1 -.3 0>
  }
  object {
    union {
      Eyeball
      scale <.15 .15 .15>
      translate <1.15 1.3 -.25>
    }
  }
  object {
    union {
      Eyeball
      rotate <0 180 0>
      scale <.15 .15 .15>
      translate <1.15 1.3 .25>
    }
  }
  object {
    quadric {
      Ellipsoid
      scale <.5 1 .35>
      rotate <0 0 90>
      translate <-.5 .5 0>
    }
    texture {YourTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <2 1.35 0>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.85 1.3 -.08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1 
      scale <.2 .4 .2>
      translate <1.85 1.3 .08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.7 1.25 -.09>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.7 1.25 .09>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.55 1.2 -.1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.55 1.2 .1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.4 1.15 -.1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth1
      scale <.2 .4 .2>
      translate <1.4 1.15 .1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <2.25 .8 0>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <2.1 .8 -.08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <2.1 .8 .08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.95 .8 -.08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.95 .8 .08>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.8 .775 -.1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.8 .775 .1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.65 .75 -.1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.65 .75 .1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2
      scale <.2 .4 .2>
      translate <1.5 .725 -.1>
    }
    texture {ToothTexture}
  }
  object {
    intersection {
      Tooth2 
      scale <.2 .4 .2>
      translate <1.5 .725 .1>
    }
    texture {ToothTexture}
  }
  rotate <0 0 -10>
  scale <1.25 1 1>
  rotate <0 30 0>
  translate <.7 -.7 -.7>
}

composite {
  EelHole2
  scale <1 1 1>
  rotate <0 -25 0>
  translate <-3 1.2 2>
}

composite {
  EelHole
  scale <1 1 1>
  rotate <0 0 0>
  translate <8 0 10>
}