//                Shelter.pov by FREDERIC MOLL   ( 100350,1766 )
//
//  A plasma globe seeks shelter from the sun 
//
//  uses the plasma globe object created by Dan Farmer
//       a glass texture created by Norm Bowler
//
//  rendering time : 640 x 480       43 minutes on a 486DX2 / 66
//

include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "stones.inc"


//  Glass texture by 

#declare NBglass=
  texture {
    pigment {color green 1 blue .99 red .98 filter .75}
    finish{
      ambient 0.1
      diffuse 0.1
      reflection .25
      refraction 1
      ior 1.5
      specular 1
      roughness .001
    }
  }


#declare NBwinebottle=
  texture { NBglass
    pigment {color red .4 green .72 blue .4 filter .6}
  }


//  declare for the plasma globe   (by Dan Farmer)

#declare DMF_Med_Purple =  colour red 0.73 green 0.16 blue 0.96 filter 0.95
#declare DMF_Light_Purple = colour red 0.87 green 0.58 blue 0.98 filter 0.85
#declare DMF_Very_DMF_Light_Purple = colour red 0.94 green 0.81 blue 0.99 filter 0.65                                         
															       
#declare DMF_Lightening_CMap1 =  color_map {                                                                                    
    [0.00 0.15 color White color DMF_Very_DMF_Light_Purple]
    [0.15 0.25 color DMF_Very_DMF_Light_Purple color DMF_Very_DMF_Light_Purple  ]                                               
    [0.25 0.30 color DMF_Very_DMF_Light_Purple  color DMF_Light_Purple ]
    [0.30 0.40 color DMF_Light_Purple  color DMF_Light_Purple ]
    [0.40 0.45 color DMF_Light_Purple  color DMF_Med_Purple ]                                                                   
    [0.50 1.00 color DMF_Med_Purple  color DMF_Med_Purple ]                                                                     
}                                                                                                                                 
																   
#declare DMF_Lightening1 = texture {                                                                                                 
    pigment {
	marble                                                                                                                     
	color_map { DMF_Lightening_CMap1 }                                                                                         
	turbulence <0.5, 0.5, 0.5>                                                                                                    
    }
    finish { ambient 1 }                                                                                                          
}                                                                                                                              
#declare DMF_Lightening_CMap2 =  color_map {
    [0.00 0.10 color White color DMF_Very_DMF_Light_Purple]                                                                    
    [0.10 0.20 color DMF_Very_DMF_Light_Purple color DMF_Very_DMF_Light_Purple  ]                                              
    [0.20 0.30 color DMF_Very_DMF_Light_Purple  color DMF_Light_Purple ]                                                         
    [0.30 0.45 color DMF_Light_Purple  color DMF_Light_Purple ]                                                                   
    [0.45 0.65 color DMF_Light_Purple  color DMF_Med_Purple ]                                                                 
    [0.65 1.00 color DMF_Med_Purple  color DMF_Med_Purple ]
}                                                                                                                             
																 
#declare DMF_Lightening2 = texture {                                                                                            
    pigment {                                                                                                                   
	granite                                                                                                                  
	color_map { DMF_Lightening_CMap2 }                                                                                     
	turbulence <0.5, 0.5, 0.5>
    }
    finish { ambient 1 }                                                                                                       
}
																  
																  
#declare DMF_Brushed_Aluminum = texture {                                                                                        
    Chrome_Metal                                                                                                               
    normal {                                                                                                                   
	bumps -0.5                                                                                                           
	scale <1, 0.001, 0.001>
    }
}


#declare DMF_Globe =
    sphere { <0,0,0>, 1.2
    texture { Glass3 
	      pigment { DMF_Light_Purple filter 0.975 } 
	      finish { ior 1 }
	     }
    }


// Two concentric inner globes textured with the lightening storm texture
#declare DMF_Plasma =
    union {
    sphere { <0,0,0>, 1.15
	texture { DMF_Lightening2 scale 1.5 }

	   }
    sphere { <0,0,0>, 0.75
	texture { DMF_Lightening1 rotate <45, 90, 30> }
	   }
}

// A shiny sphere, concentric to the globes
#declare DMF_Electrode =
    sphere { <0,0,0>, 0.35
    texture { Polished_Brass }
	    }

#declare DMF_Globe_Asm = union {
    object { DMF_Globe }
    object { DMF_Plasma }
    object { DMF_Electrode }
    bounded_by { sphere { <0,0,0>, 1.2 } }
}



//************************************************
camera {
	location <-70, 100, -170>
	look_at  <100, 60, 100 >
	}
// the lights
light_source { <-500, 800, -500> color White }
light_source { <-500, 800, -500> color White }
light_source { <-500, 800, -500> color White }


// the sky
plane { 
	y,1000 
	pigment { 
		Blue_Sky 
		scale <2000, 800, 800> 
		}
	finish {
		ambient 0.7
		} 
	rotate <1,0,0> 
	}


// A strange ground...
plane { 
	y,0
	texture { NBwinebottle }
	normal {
		wrinkles 0.5
		}
	scale <10, 100, 10>
	}

#declare size = 109.5

#declare T1 = difference {
	difference {
		union {
			cylinder { <-size, 0, 0>, <size, 0, 0>, size }
			cylinder { <0, 0, -size>, <0, 0, size>, size }
			}
		union {
			cylinder { <-size-1, 0, 0>, <size+1, 0, 0>, size-10 }
			cylinder { <0, 0, -size-1>, <0, 0, size+1>, size-10 }
			}
		}
	plane { y,0 }
}


//   the roof of the shelter
object { 
	T1 
	translate <size, 59, size>
		texture {
			Stone23   scale < 5 , 5 , 5>
		}

	}

#declare Brique = 
union {
	box { <0,0,0> <20,5,10> 
		texture {
			pigment { color Pink }  
			normal { bumps 0.6 }
			}
	}
	box { <-.5, -.5, .5> <20.5, 5.5, 9.5> 
		texture {
			pigment { color Gray70 }
		}
	}
}
#declare Rang = union {
	object { Brique translate <  0,0,0> }
	object { Brique translate < 21,0,0> }
	object { Brique translate < 42,0,0> }
	object { Brique translate < 63,0,0> }
	object { Brique translate < 84,0,0> }
	object { Brique translate <105,0,0> }
	object { Brique translate <126,0,0> }
	object { Brique translate <147,0,0> }
	object { Brique translate <168,0,0> }
	object { Brique translate <189,0,0> }
	}
#declare Mur = union {
	object { Rang translate < 0, 0,0>  }
	object { Rang translate <10, 6,0>  }
	object { Rang translate < 0,12,0>  }
	object { Rang translate <10,18,0>  }
	object { Rang translate < 0,24,0>  }
	object { Rang translate <10,30,0>  }
	object { Rang translate < 0,36,0>  }
	object { Rang translate <10,42,0>  }
	object { Rang translate < 0,48,0>  }
	object { Rang translate <10,54,0>  }
	}

//  a little wall of bricks.... (not from Pink Floyd)

object { Mur       

	}

object { Mur       
	translate <-219,0,0>
	rotate <0,90,0>
	}
object { Mur       
	rotate <0,-90,0>
	translate <219,0,0>
	}
object { Mur       
	rotate <0,180,0>
	translate <219,0,219>
       }

// A pillar

#declare T2 = union {
	cylinder { 
		<5.5, 0, 5.5> <5.5, 100 ,5.5>  8
		texture { Stone11 scale <5 , 5 , 5> }
		}
	box { 
		<-3, 100, -3> <13, 105 ,13> 
		texture { pigment { color Gray60 } }
		}
	sphere { 
		<5, 110, 5> , 8
		texture { pigment { Jade }  scale <6 , 6, 6 > }
		}
	finish {
		ambient 0.2
		} 
	}

object { T2 }
object { T2 
	translate <209,0,0>
	}
object { T2 
	translate <0,0,209>
	}
object { T2 
	translate <209,0,209>
	}

//     The plasma Glob   (original object by Dan Farmer)

object { DMF_Globe_Asm
	 scale <30 , 30 , 30>
	 translate < 105 , 118 , 105>
	}
