      /*

         Spikey Ball Object For PovRay Version 2.1

         Crafted By Editor and POVRAY (Cheers team, great software.)

         A sphere with a cone at every 45 degree point (28 Cones)
         
         Every surface has a Chrome texture, with three lights White & Gold
         above & Red below. 

         My first Raytrace (just got the software) - Hope you like it, if
         anybody knows a neater way of achieveing the Cone rotations please
         let me know!. It took a while working out the angles.

         This could be useful for placeing the rotations of the object in an
         include file so as to be able rotate any passed object... (Maybe...)
         
         POVRAY Options I used were :- RUNPOV D640 SPIKEY +A -D -X
         Creation time around 12 minutes on a 486 DX 66.

         For a spikey space mine animation with the spikes appearing from
         within the sphere use the +K input switch to POVRAY's clock variable
         with setting of 2.0 - 4.85 incremented by .15 (for twenty frames),
         which modifies the cone length [C_Leng]. (switch the commented out
         #declare statements for the clock setting).

         Then join the .TGA files with a TGA to FLI program (use which res.
         suits your kit & flick player). 

         I included a 320x240x256c GIF of the image only 9,477 bytes to give
         an idea of the what the image looks like before rendering.

      */

      #include "colors.inc"    // The include files contain
      #include "shapes.inc"    // pre-defined scene elements
      #include "textures.inc"

      #declare C_Base = .5	// Cone base radius
      #declare C_Adj  = (clock - 2) * 5

//    #declare C_Leng = clock	// Cone length
      #declare C_Leng = 5	// Cone length

      camera {
        location  < 2.12 , 2.12 ,-11>
	//rotate < C_Adj,C_Adj, 0>
	direction < 0, 0, 1>
        look_at   < 0, 0, 0>
      }

      light_source {
        <2, 4, -3> color White
      }

      light_source {
        <-2, 4, -3> color Gold
      }

      light_source {
        < 0,-8, 0> color Red
      }

      sphere {
        <0, 0, 0>, 2
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,45>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,90>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,135>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,180>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,225>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,270>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 0,315>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <45,0, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <90,0, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <135,0, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <225,0,0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <270,0,0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <315,0, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0, 45, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0,135, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0,225, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < C_Leng, 0, 0>, 0
        rotate <0,315, 0>
        texture {
          Chrome_Texture
        }
      }

      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <-45, 45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <-45,-45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <-135, 45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, C_Leng, 0>, 0
        rotate <-135,-45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, -C_Leng, 0>, 0
        rotate <-45, 45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, -C_Leng, 0>, 0
        rotate <-45,-45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, -C_Leng, 0>, 0
        rotate <-135, 45, 0>
        texture {
          Chrome_Texture
        }
      }
      cone {
        <0, 0, 0>, C_Base < 0, -C_Leng, 0>, 0
        rotate <-135,-45, 0>
        texture {
          Chrome_Texture
        }
      }

      // End of Spikey.pov


