// Persistence Of Vision raytracer version 2.0 sample file.

// By David Buck

#include "colors.inc"

camera {
   location <0.0, 10.0, 200.0>
   direction <0.0, 0.0, -1.0>
   up <0.0, 1.0, 0.0>
   right <4/3, 0.0, 0.0>
   look_at <0.0, 130.0, -300.0>
}

/* Define the ocean surface */
plane { y, -10
   pigment { colour red 1.0 green 0.3 }
   normal { waves 0.05 frequency 5000.0 scale 3000 }
   finish { reflection 1.0 }
}

/* Put a floor underneath to catch any errant waves from the ripples */
plane { y, -11.0
   pigment { colour red 1.0 green 0.3 }
   finish {
      crand 0.05
      ambient 1.0
      diffuse 0.0
   }
}

/* Now draw the sky */
sphere { <0.0, 0.0, 0.0>, 400.0
   pigment {
      gradient y
      colour_map { [0.0, 0.8 colour red 1.0 green 0.3 blue 0.0
                             colour red 0.7 green 0.7 blue 1.0]
                   [0.8, 1.0 colour red 0.7 green 0.7 blue 1.0
                             colour red 0.7 green 0.7 blue 1.0]
      }
      scale 400
   }
   finish {
      ambient 0.7
      diffuse 0.0   /* we don't want clouds casting shadows on the sky */
   }
}

/* Put in a few clouds */
sphere { <0.0, 0.0, 0.0>, 259.0
   pigment {
      bozo
      turbulence 0.5
      colour_map {
          [0.0 0.6 colour red 1.0 green 1.0 blue 1.0 filter 1.0
                   colour red 1.0 green 1.0 blue 1.0 filter 1.0]
          [0.6 0.8 colour red 1.0 green 1.0 blue 1.0 filter 1.0
                   colour red 1.0 green 1.0 blue 1.0]
          [0.8 1.001 colour red 1.0 green 1.0 blue 1.0
                     colour red 0.8 green 0.8 blue 0.8]
      }
      scale <100.0, 20.0, 100.0>
      rotate 20*y
   }
   finish {
      ambient 0.7
      diffuse 0.0
   }
}

/* Now to cast some light on the subject */
light_source {
   <0, 0, 0> color White

   looks_like {
      sphere { <0, 0, 0>, 40
         pigment { colour red 1.0 green 0.6 filter 0.35 }
         finish { ambient 1.0 diffuse 0.0 }
      }
    }

    translate <0, 60, -300>
}
