// TTBJUG Abstract for POVRAY GROUP IMAGE PROJECT
// Author:  Truman Brown CIS 71477,221
// This file is released to the Public Domain

// Item:    Simple wooden jug in a wooden stand
// Extents: stand -
//             MINX = -26.5
//             MAXX =  26.5
//             MINY =   0.0
//             MAXY =  59.0
//             MINZ = -26.5
//             MAXZ =  26.5
//          vase -
//             MINX = -12.0
//             MAXX =  12.0
//             MINY =   0.0
//             MAXY =  43.5
//             MINZ = -12.0
//             MAXZ =  12.0

#include "colors.inc"

camera {
   location <-70, 36, -116>
// location <-72,236, -320>
   direction <0, 0, 1.453>
   up        y
   sky       <0.1, 0.9, 0>
   right     <4/3, 0, 0>
   look_at  <10, 24, 0>
}

/*
light_source { <-18, 12, -18> color Gray80 spotlight point_at <0, 28, 0> tightness 0 radius 12.50 falloff 25.00 }
light_source { < 18, 12, -18> color Gray80 spotlight point_at <0, 28, 0> tightness 0 radius 12.50 falloff 25.00 }
light_source { <-18, 12,  18> color Gray80 spotlight point_at <0, 28, 0> tightness 0 radius 12.50 falloff 25.00 }
light_source { < 18, 12,  18> color Gray80 spotlight point_at <0, 28, 0> tightness 0 radius 12.50 falloff 25.00 }
light_source { <-5459, 12810,  -1550> color White area_light <0, 500, 0>, <500, 0, 0>,   7, 7 adaptive 0 jitter }
light_source { < 2559, 19910,  -8250> color White area_light <1400, 0, 0>, <0, 0, 1400>, 6, 6 adaptive 0 jitter }
light_source { <-1550,  1050,   -950> color White area_light <0, 800, 0>, <800, 0, 0>,   7, 7 adaptive 0 jitter }
light_source { <12559, 10910, -28660> color White area_light <1200, 0, 0>, <0, 0, 1200>, 6, 6 adaptive 0 jitter }
*/

light_source { <-1000,  1000,  -1000> color White }
light_source { < 1000,  1000,  -1000> color White }


#declare stand =
   object {
      union {
         box { <-26, 0, -26>, <26, 12, 26> }
         cone { <0, 12, 0>,11, <0, 16, 0>,11 }
         cone { < 15, 10,  15>, 1.5, < 15, 55,  15>, 1.5 }
         cone { < 15, 10, -15>, 1.5, < 15, 55, -15>, 1.5 }
         cone { <-15, 10,  15>, 1.5, <-15, 55,  15>, 1.5 }
         cone { <-15, 10, -15>, 1.5, <-15, 55, -15>, 1.5 }
         box { <-26, 55, -26>, <26, 59, 26> }
         bounded_by { box { <-26.5, 0, -26.5>, <26.5, 59, 26.5> } }
      }
   }

#declare vase =
   box { <-12, 16, -12>, <12, 24+7.5+6+6, 12> }

union {
   object { stand }
   object { vase }
   texture {
      pigment {
         color SemiSweetChoc
      }
      finish {
         ambient 0.3
         diffuse 0.7
      }
   }
}
