// TTBJUG for POVRAY GROUP IMAGE PROJECT
// Author:  Truman Brown CIS 71477,221
// This file is released to the Public Domain

// Item:    Simple wooden jug in a wooden stand
// Extents: stand -
//             MINX = -26.5
//             MAXX =  26.5
//             MINY =   0.0
//             MAXY =  59.0
//             MINZ = -26.5
//             MAXZ =  26.5
//          vase -
//             MINX = -12.0
//             MAXX =  12.0
//             MINY =   0.0
//             MAXY =  43.5
//             MINZ = -12.0
//             MAXZ =  12.0

#include "colors.inc"

camera {
   location <-70, 36, -116>
   direction <0, 0, 1.453>
   up        y
   sky       <0.1, 0.9, 0>
   right     <4/3, 0, 0>
   look_at  <10, 24, 0>
}

light_source { <-1000,  1000,  -1000> color White }
light_source { < 1000,  1000,  -1000> color White }

#declare ttb_br1 = 1.4
#declare ttb_br0 = 1.1

#declare ttb_wood_texture =
   texture {
      pigment {
         wood
         turbulence 0.23
         octaves 1
         color_map {
            [0.000 0.448 color red 0.220 * ttb_br0 green 0.141 * ttb_br0 blue ttb_br0 * 0.000
                         color red 0.376 * ttb_br0 green 0.278 * ttb_br0 blue ttb_br0 * 0.204]
            [0.448 0.578 color red 0.376 * ttb_br0 green 0.278 * ttb_br0 blue ttb_br0 * 0.204
                         color red 0.451 * ttb_br0 green 0.380 * ttb_br0 blue ttb_br0 * 0.369]
            [0.578 0.724 color red 0.451 * ttb_br0 green 0.380 * ttb_br0 blue ttb_br0 * 0.369
                         color red 0.259 * ttb_br0 green 0.180 * ttb_br0 blue ttb_br0 * 0.078]
            [0.724 0.879 color red 0.259 * ttb_br0 green 0.180 * ttb_br0 blue ttb_br0 * 0.078
                         color red 0.451 * ttb_br0 green 0.380 * ttb_br0 blue ttb_br0 * 0.369]
            [0.879 0.922 color red 0.451 * ttb_br0 green 0.380 * ttb_br0 blue ttb_br0 * 0.369
                         color red 0.424 * ttb_br0 green 0.325 * ttb_br0 blue ttb_br0 * 0.196]
            [0.922 0.983 color red 0.424 * ttb_br0 green 0.325 * ttb_br0 blue ttb_br0 * 0.196
                         color red 0.212 * ttb_br0 green 0.149 * ttb_br0 blue ttb_br0 * 0.075]
            [0.983 1.001 color red 0.212 * ttb_br0 green 0.149 * ttb_br0 blue ttb_br0 * 0.075
                         color red 0.220 * ttb_br0 green 0.141 * ttb_br0 blue ttb_br0 * 0.000]
         }
      }
      finish {
         ambient 0.3
         diffuse 0.7
         specular 1.0
         roughness 0.001
         reflection 0.08
      }
   }


#declare ttb_wood_texture2 =
   texture {
      pigment {
         wood
         octaves 2
         turbulence 0.32
         color_map {
            [0.000 0.448 color red 0.220*ttb_br1 green 0.141*ttb_br1 blue 0.000*ttb_br1
                         color red 0.376*ttb_br1 green 0.278*ttb_br1 blue 0.204*ttb_br1]
            [0.448 0.578 color red 0.376*ttb_br1 green 0.278*ttb_br1 blue 0.204*ttb_br1
                         color red 0.451*ttb_br1 green 0.380*ttb_br1 blue 0.369*ttb_br1]
            [0.578 0.724 color red 0.451*ttb_br1 green 0.380*ttb_br1 blue 0.369*ttb_br1
                         color red 0.259*ttb_br1 green 0.180*ttb_br1 blue 0.078*ttb_br1]
            [0.724 0.879 color red 0.259*ttb_br1 green 0.180*ttb_br1 blue 0.078*ttb_br1
                         color red 0.451*ttb_br1 green 0.380*ttb_br1 blue 0.369*ttb_br1]
            [0.879 0.922 color red 0.451*ttb_br1 green 0.380*ttb_br1 blue 0.369*ttb_br1
                         color red 0.424*ttb_br1 green 0.325*ttb_br1 blue 0.196*ttb_br1]
            [0.922 0.983 color red 0.424*ttb_br1 green 0.325*ttb_br1 blue 0.196*ttb_br1
                         color red 0.212*ttb_br1 green 0.149*ttb_br1 blue 0.075*ttb_br1]
            [0.983 1.001 color red 0.212*ttb_br1 green 0.149*ttb_br1 blue 0.075*ttb_br1
                         color red 0.220*ttb_br1 green 0.141*ttb_br1 blue 0.000*ttb_br1]
         }
      }
      finish {
         ambient 0.35
         diffuse 0.7
         phong 1.0
         phong_size 70
         reflection 0.08
      }
   }

#declare ttb_brt1 = 0.85

#declare silver_texture =
   texture {
      pigment {
         color rgbf <0.83*ttb_brt1, 0.83*ttb_brt1, 0.94*ttb_brt1, 0.9>
      }
      finish {
         ambient 0.4
         diffuse 0.6
         specular 1.0
         roughness 0.001
         phong 1.0
         phong_size 35
         refraction 1.0
         ior 1.2
         brilliance 0.5
      }
   }

#declare stand =
   object {
      union {
         union {
            union {           // stand level 1; y = 0 to 4
               difference {
                  box { <-25, 0, -25>, <25, 4, 25> }
                  cone { <-30, 4, -25>, 2, <30, 4, -25>, 2 }
                  cone { <-30, 4,  25>, 2, <30, 4,  25>, 2 }
                  cone { <-25, 4, -30>, 2, <-25, 4, 30>, 2 }
                  cone { < 25, 4, -30>, 2, < 25, 4, 30>, 2 }
               }
               sphere { <-25, 1, -25>, 1 }
               sphere { <-25, 1,  25>, 1 }
               sphere { < 25, 1, -25>, 1 }
               sphere { < 25, 1,  25>, 1 }
               cone   { <-25, 1, -25>, 1, <-25, 1,  25>, 1 }
               cone   { < 25, 1, -25>, 1, < 25, 1,  25>, 1 }
               cone   { <-25, 1, -25>, 1, < 25, 1, -25>, 1 }
               cone   { <-25, 1,  25>, 1, < 25, 1,  25>, 1 }
               bounded_by { box { <-26, 0, -26>, <26, 4, 26> } }
            }
            union {           // stand level 2; y = 4 to 11.25
               box { <-21, 4, -21>, <-17,  6, -17> }
               box { <-21, 4,  17>, <-17,  6,  21> }
               box { < 17, 4, -21>, < 21,  6, -17> }
               box { < 17, 4,  17>, < 21,  6,  21> }
               difference {
                  box { <-21, 6, -21>, < 21, 10, 21> }
                  cone { <-30, 10, -21>, 2, < 30, 10, -21>, 2 }
                  cone { <-30, 10,  21>, 2, < 30, 10,  21>, 2 }
                  cone { <-21, 10, -30>, 2, <-21, 10,  30>, 2 }
                  cone { < 21, 10, -30>, 2, < 21, 10,  30>, 2 }
               }
               torus { 2.5, 1 sturm scale <1, 0.5, 1> translate < 15, 10,  15> bounded_by { box { < 11, 8.75,  11>, < 19, 11.25,  19> } } }
               torus { 2.5, 1 sturm scale <1, 0.5, 1> translate < 15, 10, -15> bounded_by { box { < 11, 8.75, -19>, < 21, 11.25, -11> } } }
               torus { 2.5, 1 sturm scale <1, 0.5, 1> translate <-15, 10,  15> bounded_by { box { <-19, 8.75,  11>, <-11, 11.25,  19> } } }
               torus { 2.5, 1 sturm scale <1, 0.5, 1> translate <-15, 10, -15> bounded_by { box { <-19, 8.75, -19>, <-11, 11.25, -11> } } }
               bounded_by { box { <-21, 4, -21>, <21, 11.25, 21> } }
            }
            difference {      // stand level 3; y = 10 to 12
               box   { <-15, 10, -15>, <15, 12, 15> }
               cone  { <-15, 9, -15>, 4, <-15, 13, -15>, 4 }
               cone  { <-15, 9,  15>, 4, <-15, 13,  15>, 4 }
               cone  { < 15, 9, -15>, 4, < 15, 13, -15>, 4 }
               cone  { < 15, 9,  15>, 4, < 15, 13,  15>, 4 }
               torus { 4, 2 sturm translate <-15, 12, -15> }
               torus { 4, 2 sturm translate <-15, 12,  15> }
               torus { 4, 2 sturm translate < 15, 12, -15> }
               torus { 4, 2 sturm translate < 15, 12,  15> }
               cone  { <-16, 12, -15>, 2, < 16, 12, -15>, 2 }
               cone  { <-16, 12,  15>, 2, < 16, 12,  15>, 2 }
               cone  { <-15, 12, -16>, 2, <-15, 12,  16>, 2 }
               cone  { < 15, 12, -16>, 2, < 15, 12,  16>, 2 }
               bounded_by {
                  box   { <-15, 10, -15>, <15, 12, 15> }
               }
            }
            bounded_by {
               box { <-26, 0, -26>, <26, 12, 26> }
            }
            texture { ttb_wood_texture scale <850, 1.65, 125> }
         }
         union {                 // stand level 4:
            union {              // (stack); y = 12 to 16
               torus { 10, 0.5 sturm translate <0,12.5,0> bounded_by { box { <-10.5, 12, -10.5>, <10.5, 13, 10.5> } } }
               torus { 10, 0.5 sturm translate <0,13.5,0> bounded_by { box { <-10.5, 13, -10.5>, <10.5, 14, 10.5> } } }
               torus { 10, 0.5 sturm translate <0,14.5,0> bounded_by { box { <-10.5, 14, -10.5>, <10.5, 15, 10.5> } } }
               torus { 10, 0.5 sturm translate <0,15.5,0> bounded_by { box { <-10.5, 15, -10.5>, <10.5, 16, 10.5> } } }
               cone  { <0, 12, 0>, 10, <0, 16, 0>, 10 }
               bounded_by { box { <-11, 12, -11>, <11, 16, 11> } }
               texture { ttb_wood_texture scale <180, 0.2, 555> translate <0, 12, 0> }
            }
            union {              // (poles); y= 10 to 45
               cone { < 15, 10,  15>, 1.5, < 15, 55,  15>, 1.5 }
               cone { < 15, 10, -15>, 1.5, < 15, 55, -15>, 1.5 }
               cone { <-15, 10,  15>, 1.5, <-15, 55,  15>, 1.5 }
               cone { <-15, 10, -15>, 1.5, <-15, 55, -15>, 1.5 }
               bounded_by { box { <-16.5, 10, -16.5>, <16.5, 55, 16.5> } }
               texture { silver_texture }
            }
         }
         union {           // stand level 1; y = 0 to 4
            difference {
               box { <-25, 0, -25>, <25, 4, 25> }
               cone { <-30, 4, -25>, 2, <30, 4, -25>, 2 }
               cone { <-30, 4,  25>, 2, <30, 4,  25>, 2 }
               cone { <-25, 4, -30>, 2, <-25, 4, 30>, 2 }
               cone { < 25, 4, -30>, 2, < 25, 4, 30>, 2 }
            }
            sphere { <-25, 1, -25>, 1 }
            sphere { <-25, 1,  25>, 1 }
            sphere { < 25, 1, -25>, 1 }
            sphere { < 25, 1,  25>, 1 }
            cone   { <-25, 1, -25>, 1, <-25, 1,  25>, 1 }
            cone   { < 25, 1, -25>, 1, < 25, 1,  25>, 1 }
            cone   { <-25, 1, -25>, 1, < 25, 1, -25>, 1 }
            cone   { <-25, 1,  25>, 1, < 25, 1,  25>, 1 }
            texture { ttb_wood_texture scale <200, 3, 170> translate <280,-34,0> scale 1.5 }
            bounded_by { box { <-26, 0, -26>, <26, 4, 26> } }
            translate <0, 55, 0>
         }
         bounded_by { box { <-26.5, 0, -26.5>, <26.5, 59, 26.5> } }
      }
   }

#declare vase =
   union {
      // a [radius on x-axis]            = 12
      // b [radius on y-axis]            =  8
      // c [radius on z-axis]            = 12
      // desired radius at intersection  =  8
      // y value of intersection point   =  5.962847939999439
      // desired tangent angle           = 30.806981117105178
      intersection {
         difference {
            sphere { <0,0,0>, 1 scale <12, 8, 12> }
            sphere { <0,0,0>, 1 scale <12, 8, 12> scale 0.95 }
         }
         plane { <0,1,0>, 5.962847939999439 }
      }
      // 1st radius          =  8.000000000000000
      //     tangent angle   = 30.806981117105174
      // Length              =  8.198915917499228
      // A value             =  3.000000000000000
      // B value             =  1.658312395177700
      // C value             =  3.000000000000000
      intersection {
         difference {
            quadric {
               <0.111111111111111, -0.363636363636364, 0.111111111111111>,
               <0.000000000000000,  0.000000000000000, 0.000000000000000>,
               <0.000000000000000,  0.000000000000000, 0.000000000000000>,
               -1.0
            }
            quadric {
               <0.111111111111111, -0.363636363636364, 0.111111111111111>,
               <0.000000000000000,  0.000000000000000, 0.000000000000000>,
               <0.000000000000000,  0.000000000000000, 0.000000000000000>,
               -1.0
               scale 0.95
            }
         }
         plane { <0.0, 1.0, 0.0>, 0  }
         plane { <0.0,-1.0, 0.0>, 4.099457958749614 }
         translate <0.0, 5.962847939999439+4.099457958749614, 0.0>
      }
      // 1st radius          =  5.000000000000000
      //     tangent angle   = 66.893673141728442
      // Length              = 15.000000000000000
      // A value             =  3.000000000000000
      // B value             =  5.625000000000003
      // C value             =  3.000000000000000
      intersection {
         difference {
            quadric {
               <0.111111111111, -0.031604938271, 0.1111111111111>,
               <0.000000000000,  0.000000000000, 0.0000000000000>,
               <0.000000000000,  0.000000000000, 0.0000000000000>,
               -1.0
            }
            quadric {
               <0.111111111111, -0.031604938271, 0.1111111111111>,
               <0.000000000000,  0.000000000000, 0.0000000000000>,
               <0.000000000000,  0.000000000000, 0.0000000000000>,
               -1.0
               scale 0.95
            }
         }
         plane { <0.0,-1.0, 0.0>, 0 }
         plane { <0.0, 1.0, 0.0>, 7.5 }
         translate <0.0, 5.962847939999439+4.099457958749614, 0.0>
      }
      torus { (5-1.83899), 1.83899 sturm translate <0.0, 7.5 + 5.962847939999439+4.099457958749614, 0.0> }
      // a [radius on x-axis]            =  2.000000000000000
      // b [radius on y-axis]            =  2.003995899272906
      // c [radius on z-axis]            =  2.000000000000000
      // desired radius at intersection  =  1.838990000000000
      // y value of intersection point   =  0.787774190800730
      // desired tangent angle           = 66.893673141728442
      texture { ttb_wood_texture2 scale <40, 100, 30> scale 0.75 rotate <0, 60, 0> }
      translate <0, 24, 0>
      bounded_by { box { <-12, 16, -12>, <12, 24+7.5+6+6, 12> } }
   }

object { stand }
object { vase }

background { color rgb <0.1*2, 0.1*2, 0.3*2> }
