// Persistence of Vision Raytracer Version 2.0 scene file.
// Copyright 1993 James W.Devonshire
// CompuServe 71510,3265

// VFABOVE..View From Above
// Scene file depicts a satellite orbiting above the Canadian part
// of North America. A beam of light being projected represents
// a "visual" television transmission to my neighbor's satellite dish
// located in the province of Ontario, in the south central town of Erin.

// This file does not require include files.

// Stars.gif is an image used to create the background starfield as an image_map.
// Terrain.gif is an image used to create the contient's terrain as a bump_map.
// Crater5.gif is an image used to create the moon's surface as a bump_map.
// Northam.gif is an image used to create the continent as a height_field.

// Due to time restraints, none of these GIFs have been uploaded with this
// scene file. Sorry!

//Satellite Body ***************************************************************
#declare Sat =
object {
union {
union {
sphere {   <-7,0,0>,10 }
cylinder { <-12,0,0>,<12,0,0>,10 }
cylinder { <-8,0,0>,<-7,0,0>,11 }
cylinder { <-4,0,0>,<-3,0,0>,11 }
cylinder { <-1.5,0,0>,<1.5,0,0>,10.2 }
cylinder { <4,0,0>,<3,0,0>,11 }
cylinder { <8,0,0>,<7,0,0>,11 }
	pigment { color rgb <0.05,0.05,0.05> }
	finish { ambient 0.3 diffuse 0.7 brilliance 8 reflection 0.15
		 specular 1 roughness 0.1 }
bounded_by { box { <-13,-13,-13>,<13,13,13> } } }

// 1st Set of Solar Panels ********************************************
union {
 	box { <-15,-0.3,-0.3>,<15,0.3,0.3>  
	pigment { color rgb <0.15,0.15,0.15> }
	finish { ambient 0.3 diffuse 0.7
		 specular 1 roughness 0.05 }}
	box { <-50,-0.5,-10>,<-15,0.5,10> 
	pigment { checker color rgb <0.05,0.05,0.05>
                          color rgb <0.560784,0.560784,0.737255> }
	finish { ambient 0.5 diffuse 0.7
		 specular 1 roughness 0.05 }}
	box { <15,-0.5,-10>,<50,0.5,10>  
	pigment { checker color rgb <0.05,0.05,0.05>
                          color rgb <0.560784,0.560784,0.737255> }
	finish { ambient 0.5 diffuse 0.7
		 specular 1 roughness 0.05 } }
bounded_by { box { <-60,-1,-11>,<60,1,11> } }

scale <2,1,1>
rotate <45,0,0>
rotate <0,90,0>
rotate <45,0,0>  }

// 2nd Set of Solar Panels *******************************************
union {
 	box { <-15,-0.3,-0.3>,<15,0.3,0.3>  
	pigment { color rgb <0.15,0.15,0.15> }
	finish { ambient 0.3 diffuse 0.7
		 specular 1 roughness 0.05 }}
	box { <-50,-0.5,-10>,<-15,0.5,10> 
	pigment { checker color rgb <0.05,0.05,0.05>
                          color rgb <0.560784,0.560784,0.737255> }
	finish { ambient 0.5 diffuse 0.7
		 specular 1 roughness 0.05 }}
	box { <15,-0.5,-10>,<50,0.5,10>  
	pigment { checker color rgb <0.05,0.05,0.05>
                          color rgb <0.560784,0.560784,0.737255> }
	finish { ambient 0.5 diffuse 0.7
		 specular 1 roughness 0.05 }}

bounded_by { box { <-60,-1,-11>,<60,1,11> } }

 scale <2,1,1>
rotate <45,0,0>
rotate <0,90,0>
rotate <-45,0,0>  } 

// Antennas horizontal *************************************************
union {
cylinder { <10,0,0>,<20,70,0>,1 
	pigment { color rgb <1,1,0> }
	finish { ambient 0.3 diffuse 0.7 brilliance 8 reflection 0.15
		 specular 1 roughness 0.1 } }
cylinder { <10,0,0>,<20,-70,0>,1 
	pigment { color rgb <1,1,0> }
	finish { ambient 0.3 diffuse 0.7 brilliance 8 reflection 0.15
		 specular 1 roughness 0.1 } }
bounded_by { box { <11,-71,-1>,<21,71,1> } }

rotate x*90
}
 } }

object { Sat scale 0.04	rotate -y*70 translate <-5,6,0>	no_shadow }

// Visible ?? T.V. Transmission Beam
cone { < 3,0,-9 >, 0.3, < -5, 6, 0>,0 
	pigment { color rgb <1,1,1> filter 0.8 }
	finish { ambient 0.3 diffuse 0.7  }
no_shadow
}

// The Continent ********************************************************
object { height_field { gif "northam.gif" water_level 0.001 }
	translate <-0.5, -0.5, -0.5>
	scale <50, 1, 50>
	translate <-5, 0.5, 0>
texture { pigment { color rgb <0,0.2,0> }
normal { bump_map {  gif "terrain.gif" interpolate 2 bump_size 1.0 use_index  }
	 rotate <90, 0, 0> translate <-0.5, -0.5, -0.5> }
finish { ambient 0.5  diffuse 0.7 phong_size 0 roughness 0.00001 brilliance 0 ior 0  }
       scale <30, 1, 30> } }

// Planet Earth *****************************************************
object {
   sphere { <0, -500, 0>, 500 }
texture {
   pigment { color red 0.0 green 0.0 blue 0.3  }
   normal { ripples 0.8 frequency 10000.0 }
   finish { ambient 0.3  diffuse 0.7 specular 1 roughness 0.05 reflection 0.3 }
      scale 500  }
		bounded_by { sphere { <0,-500,0>,501 } } }

// Clouds ******************************************************
object {
   sphere { <0,-500,0>,502 }
texture {
   pigment { bozo turbulence 1
      colour_map {
         [0.0 0.4 color rgb <1,1,1> filter 1.0  color rgb <1,1,1> filter 1.0]
         [0.4 0.9 color rgb <1,1,1> filter 1.0  color rgb <1,1,1> ]
         [0.9 1.0 color rgb <1,1,1>  color rgb <1,1,1> ]  }
}
 finish { ambient 0.1  diffuse 0.7   }
      scale <5, 2, 5>
      rotate <30, 0, -50> }
		bounded_by { sphere { <0,-500,0>,503 } } }

// Star Field *****************************************************
object {
   plane { <0, 0, 1>, 260 }
texture {
    pigment {
            image_map { gif "stars.gif" map_type 0 interpolate 2 } }
    finish { ambient 6  diffuse 0  }
    scale <50.0 50.0 50.0> } }

// Moon *********************************************************
object {
   sphere { <40,-20,280>, 30 }
texture {	
   pigment { color rgb <0.35,0.35,0.35> } 
    normal { bump_map { gif "crater5.gif" map_type 0
    	     bump_size 3 interpolate 2 } }
finish { ambient 0.2  diffuse 0.7 }
	translate <-0.5,-0.5,0>
        scale <40,25,25>  }
bounded_by { sphere { <40,-20,280>,31 } } }


camera {
   location <0, 10,-20>
   direction <0, 0, 1>
   up <0, 1, 0>
   right <1.3, 0, 0>
   look_at <0,0,0>
}

light_source { <250, 250, -250> color rgb <0.7,0.7,0.7> }
light_source { <500, 500, 0> color rgb <0.6,0.6,0.6> }

