//this sky texture was written by Norm Bowler.

default{
  finish{
    ambient .2
    diffuse .4
  }
}

#declare Br=1 //Brightness constant for color values
#declare Br=3 //brighter colors

//more light
default{
  finish{
    ambient .3
    diffuse .7
  }
}

#declare BL1=Br*.35  //blue level for horizon
#declare BL2=Br*.05  //blue level for zenith

union {
// Sky sphere 
sphere { <0, 0, 0>, 1000
texture {
  pigment {gradient z
    color_map {
      [0   color blue BL1]
      [1   color blue BL2]
    }
    scale 800
  }
  finish {Luminous}
}
texture{
  pigment {agate
    color_map {
      [0   color Clear]
      [.75  color Clear]
      [1   color White filter .93 ]
    }
    //scale <4000,700,4000>
    scale <4000, 4000, 700>
    //translate <300,700,0>
    translate <300, 0, 700>
  
  }
  finish {Luminous}

}
texture{
  pigment {granite 
    //turbulence 1
    color_map {
      [0   color Clear]
      [.8  color Clear]

      [.8  color Gray15]
      [.92  color Gray70]
      [.92  color red 1 green .8 blue .75]
      [1   color red .95 blue 1 green .95]
    }
   scale 10}
   finish {Luminous}
}
texture {
  pigment {gradient z
    color_map {
      [0    color blue BL1 filter .1]
      [.25  color blue BL1-((BL1-BL2)*.25) filter .6]
      [.3   color blue BL1-((BL1-BL2)*.3)  filter 1]
      [.35  color Clear]
      [1    color Clear]
    }
    scale 800
  }
  finish {Luminous}
}
no_shadow
}
//clouds
plane {z  122
  pigment {bozo
    turbulence .5
    color_map {
      [0   color Clear]
      [.7  color Clear]
      [.75  color red Br*.2 green Br*.2 blue Br*.2 filter .6]
      [1   color red Br*.05 green Br*.05 blue Br*.05 filter .1]
    }
    scale <400,30,30>
    }
  finish {Luminous}
  no_shadow
}
rotate <-45, 0, 0>
}

//moon
sphere { <-36,900,44.366>, 17
  //base color
  texture {
    pigment { color Quartz}
  }
  texture  {
    pigment{leopard
      turbulence .3
      color_map {
        [0   color Clear]
        [.55 color Clear]
        [.7  color CadetBlue]
        [.75 color Clear]
        [1   color Clear]
      }
      scale 2
    }
  }
  texture  {
    pigment{leopard
      turbulence .2
      color_map {
        [0   color Clear]
        [.45 color Clear]
        [.7  color CadetBlue]
        [.8 color Clear]
        [1   color Clear]
      }
      scale 1.5
      //rotate <22,67,9>
      rotate <22, 9, 67>
      //translate <51,5,50>
      translate <51, 50, 5>
    }
  }
  texture {
    pigment{leopard
      turbulence .3
      color_map {
        [0   color Clear]
        [.4 color Clear]
        [.7  color CadetBlue]
        [.75 color Clear]
        [1   color Clear]
      }
      scale 2.5
      //translate <32,17,12>
      translate <32, 12, 17>
    }
  }
  texture {
    pigment{leopard
      turbulence .2
      color_map {
        [0   color Clear]
        [.35 color Clear]
        [.7  color CadetBlue]
        [.75 color Clear]
        [1   color Clear]
      }
      scale 3
      //rotate <38, 32, 80>
      rotate <38, 80, 32>
      //translate <62,17,12>
      translate <62, 12, 17>
    }
  }
}

