/*

WHIRL3DU.POV Test file for WHIRL3D.EXE output script files.

                      For POVRAY Version 2.1
                  (Cheers team, great software.)


This script file drives the output from Whirl3d, a whirl generator which I wrote
years ago and when I discovered POVRAY I just had to see what my whirls looked
like in 3D space, so I added the third dimension and output the .INC files.

I will release the windows version soon, the very rough a ready Turbo basic
version is ok'ish and I will upload if anybody shows any interest.

Twenty shapes & textures are defined but for this include only six are used.
(Sorry about the slightly boring textures I haven't had the time to get fully
 into textures yet, I've been to busy plotting shapes around 3D space and
 animating them into FLI files.)

The Whirl world is ( 1 > -1 ) from the origin in all directions.
The scaling that is done withing the INC is for when objects catch each other,
the one that is caught dies and the catcher should take on its mass (or should
do, I have not worked out the proper maths yet), and chases the next.

Any comments, questions or advise would be greatfully received, mail me...

Mike Young , Compuserve 100031,764

*/

#include "colors.inc"    // The include files contain
#include "shapes.inc"    // pre-defined scene elements
#include "shapes2.inc"   // pre-defined scene elements
#include "textures.inc"

#declare Object_Size = 0.01

#declare Xloc = .1	// X location of both camera & light source
#declare Yloc = .1	// Y
#declare Zloc = .1	// Z

camera {
	location <Xloc,Yloc,Zloc>
	direction < 0 ,  0, .7>		// Not sure I fully understand this
	look_at <-1.126,-1.113,-1.117>	// edge distortion yet...
}


light_source {
	<Xloc,Yloc,Zloc> color White
}

#declare MyPhong = finish { phong .8 }
#declare MyNorm  = normal { bumps -0.5 }

#declare Point001_Texture = texture { pigment { Red } finish {MyPhong} normal {MyNorm}}
#declare Point002_Texture = texture { pigment { NeonBlue } finish {MyPhong} normal {MyNorm}}
#declare Point003_Texture = texture { pigment { SummerSky } finish {MyPhong} normal {MyNorm}}
#declare Point004_Texture = texture { pigment { LimeGreen } finish {MyPhong} normal {MyNorm}}
#declare Point005_Texture = texture { pigment { Orange } finish {MyPhong} normal {MyNorm}}
#declare Point006_Texture = texture { pigment { Yellow } finish {MyPhong} normal {MyNorm}}
#declare Point007_Texture = texture { pigment { SkyBlue } finish {MyPhong} normal {MyNorm}}
#declare Point008_Texture = texture { pigment { Coral } finish {MyPhong} normal {MyNorm}}
#declare Point009_Texture = texture { pigment { Green } finish {MyPhong} normal {MyNorm}}
#declare Point010_Texture = texture { pigment { Violet } finish {MyPhong} normal {MyNorm}}
#declare Point011_Texture = texture { pigment { Plum } finish {MyPhong} normal {MyNorm}}
#declare Point012_Texture = texture { pigment { Salmon } finish {MyPhong} normal {MyNorm}}
#declare Point013_Texture = texture { pigment { RichBlue } finish {MyPhong} normal {MyNorm}}
#declare Point014_Texture = texture { pigment { Blue } finish {MyPhong} normal {MyNorm}}
#declare Point015_Texture = texture { pigment { Orchid } finish {MyPhong} normal {MyNorm}}
#declare Point016_Texture = texture { pigment { SteelBlue } finish {MyPhong} normal {MyNorm}}
#declare Point017_Texture = texture { pigment { White } finish {MyPhong} normal {MyNorm}}
#declare Point018_Texture = texture { pigment { Orange } finish {MyPhong} normal {MyNorm}}
#declare Point019_Texture = texture { pigment { Orange } finish {MyPhong} normal {MyNorm}}
#declare Point020_Texture = texture { pigment { Orange } finish {MyPhong} normal {MyNorm}}

#declare Point001_Object = sphere { <0,0,0>,Object_Size}
#declare Point002_Object = sphere { <0,0,0>,Object_Size}
#declare Point003_Object = sphere { <0,0,0>,Object_Size}
#declare Point004_Object = sphere { <0,0,0>,Object_Size}
#declare Point005_Object = sphere { <0,0,0>,Object_Size}
#declare Point006_Object = sphere { <0,0,0>,Object_Size}
#declare Point007_Object = sphere { <0,0,0>,Object_Size}
#declare Point008_Object = sphere { <0,0,0>,Object_Size}
#declare Point009_Object = sphere { <0,0,0>,Object_Size}
#declare Point010_Object = sphere { <0,0,0>,Object_Size}
#declare Point011_Object = sphere { <0,0,0>,Object_Size}
#declare Point012_Object = sphere { <0,0,0>,Object_Size}
#declare Point013_Object = sphere { <0,0,0>,Object_Size}
#declare Point014_Object = sphere { <0,0,0>,Object_Size}
#declare Point015_Object = sphere { <0,0,0>,Object_Size}
#declare Point016_Object = sphere { <0,0,0>,Object_Size}
#declare Point017_Object = sphere { <0,0,0>,Object_Size}
#declare Point018_Object = sphere { <0,0,0>,Object_Size}
#declare Point019_Object = sphere { <0,0,0>,Object_Size}
#declare Point020_Object = sphere { <0,0,0>,Object_Size}

#include "whirl001.inc"     // Whirl include


