// Persistence Of Vision raytracer version 2.0 

// By Michael J Leon
//    Chatsworth, CA

// Title-"Reality Windows"
// 05/19/94 

// Any suggestions or comments, I'm at 742740,1110

#include "winreal.inc"     
#include "shapes.inc"
#include "colors.inc"
#include "textures.inc" 

camera{ location <0,0,-165>
	look_at <0,0,0>}


// Place Lights in Blue Sky

light_source{<55,30,-195>color red 0.752941 green 0.752941 blue 0.752941}    
light_source{<-55,30,-195>color red 0.752941 green 0.752941 blue 0.752941}

// Blue Sky

sphere {<0,0,0>,340
	texture{pigment{bozo
	turbulence 0.6
	color_map {
					[0.0 0.6   color red 0.5 green 0.5 blue 1.0
			   color red 0.5 green 0.5 blue 1.0]
					[0.6 0.8   color red 0.5 green 0.5 blue 1.0
			   color red 1.0 green 1.0 blue 1.0]
					[0.8 1.001 color red 1.0 green 1.0 blue 1.0
			   color red 0.8 green 0.8 blue 0.8]}
					scale <105,50,200>}
	finish{ambient 0.8 diffuse 0.0 }}
	}

// Build Wood Window sides    

union   {object{box1 translate<-55,59,-1.5>}
	 object{box2 translate<-55,59,-1.5>}
	 object{box3 translate<-55,59,-1.5>}
	 
	 texture{Rosewood
	 rotate <0,40,10>
	 scale 10}              
	 finish{diffuse 0.7}         
	 }

union   {object{box1 translate<55.25,58.9,-1.5>}
	 object{box2 translate<55.25,58.9,-1.5>}
	 object{box3 translate<55.25,58.9,-1.5>}
	 texture{Rosewood
	 rotate <0,50,10>
	 scale 10}              
	 finish{diffuse 0.7}         
	 }

// Carved Rosewood top board

difference{
					box{<-50,64,3.55><50,48.5,-0.55>}

					object{DD translate<0,102,-1.05>
						rotate <0,0,0>
						scale 0.55}

					object{DD translate<0,102,-1.05>
						rotate <0,180,0>
						scale 0.55}

					object{DD translate<23,102,-1.05>
						rotate <0,0,0>
						scale 0.55}

					object{DD translate<23,102,-1.05>
						rotate <0,180,0>
						scale 0.55}

					object{DD translate<46,102,-1.05>
						rotate <0,0,0>
						scale 0.55}

					object{DD translate<46,102,-1.05>
						rotate <0,180,0>
						scale 0.55}

					object{DD translate<69,102,-1.05>
						rotate <0,0,0>
						scale 0.55}

					object{DD translate<69,102,-1.05>
						rotate <0,180,0>
						scale 0.55}

			      texture{Rosewood
				rotate <45,0,50>
				scale 10}              
				finish{diffuse 0.7}         
					}        

// Carved Rosewood slats

difference{
			box{<-50.25,50,1.5><50.25,47.5,0.5>}

			cylinder{<-50.25,48.75,0.34><50.25,48.75,0.34>1}

			texture{Rosewood
			rotate <0,0,0>
			scale 10}    
		  }           

difference{
			box{<-50.25,47.3,1.5><50.25,44.7,0.5>}                 
	
			cylinder{<-50.25,45.95,0.34><50.25,45.95,0.34>1}
	
			texture{Rosewood
		     rotate <0,20,20>
			scale 10}    
			}             
	
difference{
		       box{<-50.25,44.5,1.5><50.25,42.0,0.5>}               
	
			cylinder{<-50.25,43.25,0.34><50.25,43.25,0.34>1}

			texture{Rosewood
			rotate <0,0,30>
			     scale 10}    
			}    
	
difference{
			box{<-50.25,41.8,1.5><50.25,39.4,0.5>}               
	
			cylinder{<-50.25,40.3,0.33><50.25,40.3,0.33>1}

			texture{Rosewood
			rotate <30,0,0>
			scale 10}    
			}           
	
difference{
			box{<-50.25,39.2,1.5><50.25,36.6,0.5>}

			cylinder{<-50.25,37.85,0.33><50.25,37.85,0.33>1}

			texture{Rosewood
			rotate <0,0,40>
			scale 10}    
			}           
	
difference{        
			box{<-50.25,36.4,1.5><50.25,33.9,0.5>}  

			cylinder{<-50.25,35.15,0.34><50.25,35.15,0.34>1}

			texture{Rosewood
			rotate <40,0,0>
			scale 10}    
			}             
	
difference{        
			box{<-50.25,33.7,1.5><50.25,31.2,0.5>} 
	
			cylinder{<-50.25,32.45,0.34><50.25,32.45,0.34>1}

			texture{Rosewood
			rotate <0,0,10>
			scale 10}    
			}    
	
difference{
			box{<-50.25,31.2,1.5><50.25,28.5,0.5>} 
	
			cylinder{<-50.25,29.75,0.34><50.25,29.75,0.34>1}

			texture{Rosewood
			rotate <30,0,0>
			scale 10}    
			}           

difference{
			box{<-50.25,28.3,1.5><50.25,25.8,0.5>} 
	
			cylinder{<-50.25,27.05,0.34><50.25,27.05,0.34>1}

			texture{Rosewood
			rotate <0,0,10>
			scale 10}    
			}             

difference{
			box{<-50.25,25.7,1.5><50.25,23.1,0.5>} 
	
			cylinder{<-50.25,24.35,0.34><50.25,24.35,0.34>1}

			texture{Rosewood
			rotate <30,0,0>
			scale 10}    
			}    

box{<-50.25,23,1.5><50.25,15,0.5> 
	texture{Rosewood
	rotate <0,0,0>
	scale 10}    
	}    

// Brass handle on Rosewood window

difference{
		       cylinder{<-8,18.75,-1><8,18.75,-1>1.5}

			cylinder{<-6.75,18.75,-1><6.75,18.75,-1>0.5}

			cylinder{<-6.25,16.95,-2><6.25,16.95,-2>1}

			pigment{Brass}
			finish{Shiny}
			}

sphere{<-8,18.75,-1>1.5
	pigment{Brass}
	finish{Shiny}
	}

sphere{<8,18.75,-1>1.5
	pigment{Brass}
	finish{Shiny}
	}

// Rosewood window sides

union   {box{<-60.25,52,0.75><-50.25,-60,-0.5>}

		cylinder{<-55.25,50,0.75><-55.25,-60,0.25>3}           
	
		cylinder{<-51,50,-0.25><-51,-60,-0.75>1.25}         

		cylinder{<-59.25,50,-0.25><-59.25,-60,-0.75>1}         
	
		texture{Rosewood
		turbulence 0.05 lambda 1.5 omega 0.75 octaves 8
		rotate<67,10,0>
		scale 10}  
		finish{diffuse 0.7}
		}

union   {box{<60.25,50,0.75><50.25,-60,-0.5>}

		cylinder{<55.25,50,0.75><55.25,-60,0.25>3}           
	
		     cylinder{<51,50,-0.25><51,-60,-0.75>1.25}             
      
			  cylinder{<59.25,50,-0.25><59.25,-60,-0.75>1}    
	
		texture{Rosewood
		turbulence 0.05 lambda 1.5 omega 0.75 octaves 8
		rotate<90,0,10>
		scale 10}
		finish{diffuse 0.7}
		}

// Rosewood window sill

union   {box{<62,-60,-1><-62,-64,1.75>}

		cylinder{<62,-62,-1><-62,-62,-1>2}

		texture{Rosewood
		turbulence 0.05 lambda 1.5 omega 0.75 octaves 8
		rotate<90,20,10>
		scale 10}
		finish{diffuse 0.7}
		}

difference{
			box{<60,-64.25,-0.5><-60,-72.25,1.75>}

			cylinder{<55,-68.25,-0.5><-55,-68.25,-0.5>2}

			sphere{<55,-68.25,-0.5>2}

			sphere{<-55,-68.25,-0.5>2}    
	
			texture{Rosewood
			turbulence 0.05 lambda 1.5 omega 0.75 octaves 8
			rotate<20,90,10>
			scale 10}
			finish{diffuse 0.7}
			}

// Place Sky (starfield) and light inside Wood Window

light_source {<100,30,275> color red 1 green .8 blue .65 }

box {<-145,112,268><145,-185,300>
	inverse
	texture{pigment{A4 translate <0,200,0>
	scale 100
	rotate <20,20,0>}
	finish{ambient 0.6 diffuse 0.0}}
	}

// Place clouds inside Wood Window      

box {<-145,112,266><145,-185,300>   
	inverse
	texture{pigment{A2
	scale <300,9,30>}
	finish{ambient 0.7 diffuse 0.0}}
	}

// Place blob_things

object{Blob2 translate<-155,-30,190>
	rotate<0,20,20>
	texture{pigment{bozo
	turbulence 0.6
	color_map {
					[0.0 0.6   color red 0.5 green 0.5 blue 1.0
			   color red 0.5 green 0.5 blue 1.0]
					[0.6 0.8   color red 0.5 green 0.5 blue 1.0
			   color red 1.0 green 1.0 blue 1.0]
					[0.8 1.001 color red 1.0 green 1.0 blue 1.0
			   color red 0.8 green 0.8 blue 0.8]}
							scale <105,50,200>}
	finish{Shiny}}
	     }

object{Blob2 translate<-65,40,-50>
	       rotate<-5,-20,20>
	  texture{pigment{A5
			 scale <300,9,30>}
	  finish{Shiny}}
		    }

object{Blob2 translate<15,5,230>
	rotate<10,20,-20>
	texture{pigment{A6 
		  scale <300,9,30>}
	finish{Shiny}}
	}

// Place White Window inside Wood Window

object{XYZ translate<0,-5,23>
	scale 6}

// Place Sky and light inside White Window
			
box {<-40,3,265><40,-127,300>
	inverse
	texture{pigment{A1 translate <0,200,0>
		  rotate <0,0,90>        
		  scale <300,9,30>}
	finish{ambient 0.6 diffuse 0.0}}
	}

// Place Clouds inside White Window

box {<-40,3,260><40,-127,300>   
	inverse
	texture{pigment{A3
		  rotate <0,90,0>    
	scale <300,9,30>}
	finish{ambient 0.7 diffuse 0.0}}
	}

light_source{<-50,30,220> color red 1 green .8 blue .65 } 
light_source{<-35,-30,215>color red 1.0 green 1.0 blue 1.0}     
light_source{<35,-5,215>color red 1.0 green 1.0 blue 1.0}

// Place Chain Links through all Windows

object{C2 translate<0,-57,0>}
