//------POV 2.0 INCLUDE FILE FOR XMAS2.POV
//---------------- A CHRISTMAS CARD, CANDLE, CANDYCANE, CANDLE HOLDER.
//---------------------------- Jim Devonshire 1992-93
#declare JimGold =
texture { Brass_Metal }

#declare CenterHolder =
composite {
// tube
object {
	difference { intersection { Disk_Y scale < 1.2 1.5 1.2 > }
	intersection { Disk_Y scale <1.19 1.49 1.19> translate <0 0.2 0> } }
	texture { JimGold}
	bounded_by { intersection { Disk_Y scale <1.5 2.2 1.5 > } } }

// tubeTop
object { intersection {	difference {
	sphere { < 0 0 0 > 15 }
	sphere { < 0 0 0 > 8  } } 
	plane { < 0 1 0 > 1 }
	plane { < 0 1 0 > -1 inverse }}
texture { JimGold }
	bounded_by { sphere { <0 0 0 > 16 } }
scale < 0.15 0.15 0.15 >
translate < 0 1.65 0 >}}

#declare CandlHolder = 
composite {
// Bowl
object { intersection {	difference {
	sphere { < 0 0 0 > 12 }
	sphere { < 0 8 0 > 16  } }
	plane { < 0 1 0 > -4   }
	plane { < 0 1 0 > -4  inverse translate <0 -4 0> } }
texture { JimGold }
	bounded_by { sphere { <0 0 0 > 13 } } }
// Handle
object { intersection {	difference {
	sphere { < 0 0 0 > 10 }
	sphere { < 0 0 0 > 9  } }
	plane { < 0 1 0 > 1 }
	plane { < 0 1 0 > -2 inverse translate < 0 -3 0 > } }
texture { JimGold }
	bounded_by { sphere { <0 0 0 > 11 } }
scale < 0.35 0.35 0.35 >
rotate < 90 0 0 >
translate < 13.5 -3 0 > } }

#declare CanYellow = color red 1.0 green 1.0 blue 0.7
#declare CandleColor = texture { ambient 0.3 diffuse 0.7  color Red
	specular 1 roughness 0.05 }

#declare WickBottom =
texture { color red 0.85 green 0.85 blue 0.85 ambient 0.3 diffuse 0.7 }

#declare WickTop =
texture { color red 0.45 green 0.45 blue 0.45 ambient 0.3 diffuse 0.7 }

#declare Drool =
object { quartic { Piriform sturm rotate <0 0 -90>}
texture { CandleColor }
bounded_by { quadric { Ellipsoid translate < 0 -0.8 0 > scale <0.8 0.8 0.8> }}}

#declare Ellipsoid = quadric {
    <1 1 1>
    <0 0 0>
    <0 0 0>
    -1
 }

#declare Cylinder_Y = quadric {
   <1.0 0.0 1.0>
   <0.0 0.0 0.0>
   <0.0 0.0 0.0>
   -1.0
}

#declare CandleBod =
intersection { quadric { Cylinder_Y  }
   plane { <0.0 1.0 0.0> -1 inverse }
   plane { <0.0 1.0 0.0>  1 rotate <0 0 -5> } }

#declare Disk_Y =
intersection { quadric { Cylinder_Y  }
   plane { <0.0 1.0 0.0> -1 inverse }
   plane { <0.0 1.0 0.0>  1  } }

#declare Flame =
object { quartic { Piriform sturm rotate <0 0 -90> translate < 0 1 0 >}
texture { wood color_map { [ 0.00 1.001 color Yellow color Red alpha 1.0 ] }
	ambient 1.0 diffuse 0.3	scale <4 5 1> rotate <0 -8 0> }
bounded_by { quadric { Ellipsoid scale <0.9 0.8 0.9 > translate <0 0.5 0 >} }
scale <5 20 0.5> }

#declare CandlUnit =
composite {
object { // Candle
difference { intersection { CandleBod scale <1 4 1> }
sphere { <0.3 4.5 0> 1.1 }} texture { CandleColor }
bounded_by { quadric { Ellipsoid scale <2 6 2> } } rotate < 0 60 0 > }

// Wick Bottom not burned
object { intersection { Disk_Y } scale <0.09 1.5 0.09> translate <0 2.8 0>
	texture { WickBottom scale <0.09 0.09 0.09> } }
//Wick Top burned
object { intersection { Disk_Y } scale <0.08 1.5 0.08> translate <0 3.1 0>
	texture { WickTop scale <0.08 0.08 0.08> } }
object { Flame  scale < 0.15 0.15 0.15 > translate < 0 4 0 > } /* 4.3*/
object {  Drool  scale < 0.2 1 0.2 > translate <0.6 3.7 -0.8> }
object {  Drool  scale < 0.2 1 0.2 > translate <0.8 3.68 -0.6> }
object {  Drool  scale < 0.2 2 0.2 > translate <0.8 3.7 -0.6> }
object {  Drool  scale < 0.2 1.7 0.2 > translate <0.5 3.66 -0.88> }
object {  Drool  scale < 0.2 3 0.2 > translate <0.5 3.5 -0.8> } }

#declare Card =
composite {
object { box { UnitBox  }
texture { ambient 0.5 diffuse 0.7  phong 0.5 phong_size 10 color White }
texture { ambient 0.3 diffuse 0.7
image_map { gif "snowman.gif" map_type 0 once interpolate 2 alpha 1 1.0 }
translate <-0.5 -0.5 0.0> scale <1 1.5 1> translate <0 -0.2 0> }
scale < 2 3 0.05 >
rotate < 0 -65 0>
translate < -1.8 0 0> }

object { box { UnitBox  }
texture { ambient 0.3 diffuse 0.7 phong 0.5 phong_size 10 color White }

texture { ambient 0.3 diffuse 0.7
image_map { gif "salutat.gif" map_type 0 once interpolate 2 alpha 0 1.0 }
translate <-0.5 -0.5 0.0> scale <2 2 1>	translate < 0 0.2 0> }

texture {
image_map { gif "sleigh.gif" map_type 0 once interpolate 2 alpha 1 1.0 }
translate <-0.5 -0.5 0.0> scale <1 0.5 1>	translate < 0 -0.5 0> }
scale < 2 3 0.05 > translate < 1 0 2> } }

// Table
#declare Table = 
object { box { UnitBox  }
texture { DMFLightOak turbulence 0.15
scale <3 1 1> rotate <70 0 0> rotate <0 -1 0> 
ambient 0.3 diffuse 0.7 phong 0.5 phong_size 10 reflection 0.2 }
bounded_by { box { UnitBox scale <4.1 0.3 4.1> } } scale < 9 0.2 9 > }

#declare Cane =
composite {
object { difference {
	quartic {
	<  1   0   0   0   2   0   0   2   0
	 -25   0   0   0   0   0   0   0   0
	   0   0   1   0   0   2   0  24   0
	   0   0   0   1   0 -25   0 144 >
rotate <90 0 0>	 }
plane { <0 1 0> 0  } }
texture { color White ambient 0.3 diffuse 0.7 specular 1.0 roughness 0.05 }
texture { ambient 0.3 diffuse 0.7 image_map { gif "canemap.gif" map_type 0 
interpolate 2 alpha 0 1.0  }
translate <-0.5 -0.5 0.0> scale <30 30 30> rotate < 0 0 45> } }
object { intersection { Disk_Y }  
texture { color White ambient 0.3 diffuse 0.7 specular 1.0 roughness 0.05 }
texture { ambient 0.3 diffuse 0.7 image_map { gif "canemap.gif" map_type 0 
interpolate 2 alpha 0 1.0 }
translate <-0.5 -0.5 0.0> scale <6 6 6>	rotate < 0 0 5>	translate < 0 0.2 0> }
scale <0.5 8 0.5>  translate < -3.5 -8 0 > }
bounded_by { box { UnitBox scale < 5 10 1.5 > translate < 0 -5.5 0> } } }

#declare or =
object {  /* Outer Ring */
   quartic {
   < 1.0   0.0   0.0    0.0     2.0   0.0   0.0   2.0   0.0  -57.0
     0.0   0.0   0.0    0.0     0.0   0.0   0.0   0.0   0.0    0.0
     1.0   0.0   0.0    2.0     0.0  56.0   0.0   0.0   0.0    0.0
     1.0   0.0 -57.0    0.0   800.0 >
    }
texture { JimGold }
    bounded_by { sphere { <0 0 0> 10  }  } rotate <90 0 0> }

#declare Center =
composite {
composite { CenterHolder scale < 0.7 0.7 0.7>  translate < 0 0.5 0 > }
composite { CandlUnit scale < 0.65 0.65 0.65> translate < 0 2.01 0 > }
}

#declare WholeCandleUnit =
composite {
composite { Center translate < 0 0.7 0>}
composite { CandlHolder scale < 0.3 0.3 0.3 > rotate <0 35 0> translate < 0 2.5 0> }
}
